package com.huimv.dataprocess.dao.entity;

import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.GenerationType;
import lombok.experimental.Accessors;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import java.sql.Timestamp;
import lombok.Data;
import java.io.Serializable;
import javax.persistence.Id;
 
@Entity
@Table(name = "eartag_data")
@Data
@Accessors(chain = true)
public class EartagDataEntity implements Serializable {

private static final long serialVersionUID = 1L;

/**
 * 记录id(主键)
 */
@Id
@GeneratedValue(strategy = GenerationType.IDENTITY)@Column(name = "id", nullable = false)
private Integer id;

/**
 * 组织id
 */
@Column(name = "org_id")
private Long orgId;

/**
 * 采集器编码
 */
@Column(name = "device_code")
private String deviceCode;

/**
 * 耳标号
 */
@Column(name = "eartag_no")
private String eartagNo;

/**
 * 采集时间
 */
@Column(name = "time")
private Timestamp time;

/**
 * 耳根温度
 */
@Column(name = "ear_temp")
private Double earTemp;

/**
 * 运动量
 */
@Column(name = "exercise")
private Integer exercise;

/**
 * 栋舍
 */
@Column(name = "pigpen")
private String pigpen;

/**
 * 单元ID
 */
@Column(name = "unit_id")
private Integer unitId;

/**
 * 环境温度
 */
@Column(name = "env_temp")
private Double envTemp;

/**
 * 电池电量
 */
@Column(name = "bat")
private Integer bat;

/**
 * 信号强度
 */
@Column(name = "rssi")
private Integer rssi;

/**
 * 命令头
 */
@Column(name = "head")
private String head;

/**
 * 指令
 */
@Column(name = "command")
private String command;

/**
 * 版本号
 */
@Column(name = "version")
private String version;

/**
 * 耳标帧序号
 */
@Column(name = "frame_serial_no")
private Integer frameSerialNo;

/**
 * 重启次数
 */
@Column(name = "reboot_times")
private Integer rebootTimes;

/**
 * 预留字段
 */
@Column(name = "prepare_field")
private String prepareField;

/**
 * 校验码
 */
@Column(name = "chk")
private String chk;

/**
 * 命令尾
 */
@Column(name = "tail")
private String tail;

/**
 * 牧场编码
 */
@Column(name = "farm_code")
private String farmCode;

/**
 * 阶段
 */
@Column(name = "stage")
private Integer stage;

@Column(name = "sport_gap")
private Integer sportGap;

/**
 * 耳标上传运动量
 */
@Column(name = "old_exercise")
private Integer oldExercise;

}
