package com.huimv.eartag2.api.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.pojo.BaseFarmer;
import com.huimv.eartag2.api.service.BaseFarmerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-08-30
 */
@RestController
@RequestMapping("/farmer")
public class BaseFarmerController {

    @Autowired
    private BaseFarmerService baseFarmerService;
    
    @PostMapping("/add")
    public Result add(@RequestBody Map<String, Object> paramsMap) throws ParseException {
        return baseFarmerService.add(paramsMap);
    }

    @PostMapping("/edit")
    public Result edit(@RequestBody Map<String, Object> paramsMap) throws ParseException {
        return baseFarmerService.edit(paramsMap);
    }

    @PostMapping("/remove")
    public Result remove(@RequestBody Map<String, Object> paramsMap) throws ParseException {
        return baseFarmerService.remove(paramsMap);
    }

    @PostMapping("/list")
    public Result listByFarmCode(@RequestBody Map<String, Object> paramsMap) throws ParseException {
        return baseFarmerService.list(paramsMap);
    }
    @PostMapping("/listAll")
    public Result listAll(@RequestBody Map<String, String> paramsMap) {
        String farmCode = paramsMap.get("farmId");

        return new Result(ResultCode.SUCCESS, baseFarmerService.list(new QueryWrapper<BaseFarmer>().eq(StringUtils.isNotBlank(farmCode),"farm_code",farmCode)));
    }


//    @PostMapping("/getLastAdoptByFarmCode")
//    public Result getLastAdoptByFarmCode(@RequestBody Map<String, Object> paramsMap) throws ParseException {
//        return baseFarmerService.getLastAdoptByFarmCode(paramsMap);
//    }
}

