package com.huimv.eartag2.api.controller;

import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.api.service.BizBaseStageService;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-07-23
 */
@RestController
@RequestMapping("/bizBaseStage")
public class BizBaseStageController {

    @Resource
    private BizBaseStageService bizBaseStageService;

    @PostMapping("/add")
    private Result addBizBaseStage(@RequestBody Map<String,String> param){
      return bizBaseStageService.addBizBaseStage(param);
    }

    @PostMapping("/remove")
    private Result removeBizBaseStage(@RequestBody List<String> ids){
        return bizBaseStageService.removeBizBaseStage(ids);
    }

    @PostMapping("/update")
    private Result updateBizBaseStage(@RequestBody Map<String,String> param){
        return bizBaseStageService.updateBizBaseStage(param);
    }

    @PostMapping("/list")
    private Result listBizBaseStage(@RequestBody Map<String,String> param){
       return bizBaseStageService.listBizBaseStage(param);
    }

    @GetMapping ("/getData")
     private Result getDataById(@Param("id") String id){
        return bizBaseStageService.getDataById(id);
    }
}

