package com.huimv.eartag2.api.controller;


import com.huimv.eartag2.common.common.token.TokenSign;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.api.service.IEartagData2Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2022-07-29
 */
@RestController
@RequestMapping("/eartagData")
public class EartagData2Controller {
    @Autowired
    private IEartagData2Service eartagDataService;

    @PostMapping("/getEnvByTime")
    public Result getEnvByTime(@RequestBody Map<String,String> map, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        map.put("userId",userId+"");
        return eartagDataService.getEnvByTime(map);
    }

    @PostMapping("/api/getEnvByTime")
    public Result getEnvByTime2(@RequestBody Map<String,String> map, HttpServletRequest request){
        return eartagDataService.getEnvByTime2(map);
    }

    /**
     * @Method      : getEartagDataByEarmark
     * @Description : earmark,startDate,endDate
     * @Params      : [map, request]
     * @Return      : com.huimv.eartag2.common.utils.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/10/15       
     * @Time        : 15:55
     */
    @PostMapping("/api/getEartagDataByEarmark")
    public Result getEartagDataByEarmark(@RequestBody Map<String,String> map, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        map.put("userId",userId+"");
        return eartagDataService.getEartagDataByEarmark(map);
    }

    @PostMapping("/api/eartagData/getTemp")
    public Result getTemp(@RequestBody Map<String,String> map){

        return eartagDataService.getTemp(map);
    }

    @PostMapping("/api/eartagData/getAct")
    public Result getAct(@RequestBody Map<String,String> map){

        return eartagDataService.getAct(map);
    }

    @PostMapping("/api/qingshan/countEartag")
    public Result countEartag(@RequestBody Map<String,String> map){

        return eartagDataService.countEartag(map);
    }
}
