package com.huimv.eartag2.api.controller;


import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.api.service.EartagDeviceRegisterService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-07-22
 */
@RestController
@RequestMapping("/eartag-device-register")
public class EartagDeviceRegisterController {

    @Resource
    private EartagDeviceRegisterService eartagDeviceRegisterService;

    /**
     * @description: 【添加】设置栋舍单元
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/setPigpen")
    public Result setDeviceRegister(@RequestBody List<Map<String, String>> maps){
        return eartagDeviceRegisterService.set(maps);
    }


    @PostMapping("/setFarmer")
    public Result setFarmer(@RequestBody List<Map<String, Integer>> maps){
        return eartagDeviceRegisterService.setFarmer(maps);
    }
    /**
     * @description: 【删除】
     * @author: 静静
     * @param: ids
     **/
    @PostMapping("/remove")
    public Result removeDeviceRegister(@RequestBody String ids){
        return eartagDeviceRegisterService.remove(ids);
    }

    /**
     * @description: 【修改】
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/update")
    public Result updateDeviceRegister(@RequestBody  Map<String, String> maps){
        return eartagDeviceRegisterService.update(maps);
    }
    /**
     * @description: 【查询】 分页查询
     * @author: 静静
     * @param: paramsMap
     **/
    @PostMapping("/list")
    public Result list(@RequestBody Map<String,String> paramsMap){
        return eartagDeviceRegisterService.list(paramsMap);
    }

    /**
     * @description: 【增加】
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/add")
    public Result add(@RequestBody Map<String, String> maps){
        return eartagDeviceRegisterService.add(maps);
    }

    /**
     * @description: 【删除】取消栋舍单元设置
     * @author: 静静
     **/
    @PostMapping("/cancel")
    public Result cancelPigpen(@RequestBody String ids){
        return eartagDeviceRegisterService.cancel(ids);
    }

    /**
     * @description: 【查询】根据farmID获取设备编码
     * @author: 静静
     **/
    @GetMapping("/getDeviceCode")
    public Result getDeviceCode(@RequestParam(name = "farmId") String farmCode){
        return eartagDeviceRegisterService.getDeviceCode(farmCode);
    }
}

