package com.huimv.eartag2.api.controller;

import com.huimv.eartag2.common.common.token.TokenSign;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.api.service.IEartagEartagRegister2Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : 耳标注册
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@RestController
@RequestMapping("/eartagRegister")
public class EartagRegisterController {
    @Autowired
    private IEartagEartagRegister2Service eartagRegisterService;

   /* @RequestMapping("/listFarmUnitEartagData")
    public Result listFarmUnitEartagData(@RequestBody Map<String, String> params){
        return eartagRegisterService.listFarmUnitEartagData(params);
    }*/

    @RequestMapping("/listFarmUnitEartagData")
    public Result listFarmUnitEartagData(@RequestBody Map<String, String> params, HttpServletRequest req){
        Integer userId = TokenSign.getMemberIdByJwtToken(req);
        params.put("userId",userId+"");
        return eartagRegisterService.listFarmUnitEartagData(params);
    }
    @PostMapping("/listUserEartagData")
    public Result listUserEartagData(@RequestBody Map<String, String> params, HttpServletRequest req){
        Integer userId = TokenSign.getMemberIdByJwtToken(req);
        params.put("userId",userId+"");
        return eartagRegisterService.listUserEartagData(params);
    }

    @RequestMapping("/listFarmUnitEartagData2")
    public Result listFarmUnitEartagData2(@RequestBody Map<String, String> params, HttpServletRequest req){
        Integer userId = TokenSign.getMemberIdByJwtToken(req);
        params.put("userId",userId+"");
        return eartagRegisterService.listFarmUnitEartagData2(params);
    }

    @RequestMapping("/listFarmUnitEartagDataByFarmer")
    public Result listFarmUnitEartagDataByFarmer(@RequestBody Map<String, String> params){
        return eartagRegisterService.listFarmUnitEartagDataByFarmer(params);
    }

    @RequestMapping("/removeByEarmark")
    public Result removeByEarmark(@RequestBody Map<String, String> params, HttpServletRequest req){
        return eartagRegisterService.removeByEarmark(params,req);
    }

}
