package com.huimv.eartag2.api.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.pojo.BaseFarmer;
import com.huimv.eartag2.api.mapper.BaseFarmerMapper;
import com.huimv.eartag2.api.service.BaseFarmerService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-08-30
 */
@Service
public class BaseFarmerServiceImpl extends ServiceImpl<BaseFarmerMapper, BaseFarmer> implements BaseFarmerService {
    @Autowired
    private BaseFarmerMapper baseFarmerMapper;

    @Override
    public Result add(Map<String, Object> paramsMap) {
        BaseFarmer baseFarmer = new BaseFarmer();
        baseFarmer.setFarmer(paramsMap.get("farmer")+"");
        baseFarmer.setPhone(paramsMap.get("phone")+"");
        baseFarmer.setAddress(paramsMap.get("address")+"");
        baseFarmer.setFarmCode(paramsMap.get("farmId")+"");
        int rows = baseFarmerMapper.insert(baseFarmer);
        if(rows > 0){
            return new Result(ResultCode.SUCCESS);
        }else{
            return new Result(ResultCode.FAIL);
        }
    }

    @Override
    public Result edit(Map<String, Object> paramsMap) {
        BaseFarmer baseFarmer = new BaseFarmer();
        baseFarmer.setId(Integer.parseInt(paramsMap.get("id")+""));
        baseFarmer.setFarmer(paramsMap.get("farmer")+"");
        baseFarmer.setPhone(paramsMap.get("phone")+"");
        baseFarmer.setAddress(paramsMap.get("address")+"");
//        baseFarmer.setFarmCode(paramsMap.get("farmId")+"");
        int rows = baseFarmerMapper.updateById(baseFarmer);
        if(rows > 0){
            return new Result(ResultCode.SUCCESS);
        }else{
            return new Result(ResultCode.FAIL);
        }
    }

    @Override
    public Result remove(Map<String, Object> paramsMap) {
        String ids = paramsMap.get("ids")+"";
        List<Integer> idList = new ArrayList<>();
        String[] idArray = ids.split(",");
        for(int a=0;a<idArray.length;a++){
            idList.add(Integer.parseInt(idArray[a]));
        }
        int rows = baseFarmerMapper.deleteBatchIds(idList);
        if(rows > 0){
            return new Result(ResultCode.SUCCESS);
        }else{
            return new Result(ResultCode.FAIL);
        }
    }

    @Override
    public Result list(Map<String, Object> paramsMap) {
        //
        String farmCode = paramsMap.get("farmId")+"";
        String farmer = paramsMap.get("farmer")+"";
        Integer pageNo = Integer.parseInt(paramsMap.get("pageNo")+"");
        Integer pageSize = Integer.parseInt(paramsMap.get("pageSize")+"");
        QueryWrapper<BaseFarmer> queryWrapper = new QueryWrapper();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.like(StringUtils.isNotBlank(farmer),"farmer",farmer);
        Page<BaseFarmer> page = new Page<>(Integer.valueOf(pageNo), Integer.valueOf(pageSize));
        return new Result(ResultCode.SUCCESS,baseFarmerMapper.selectPage(page,queryWrapper));
    }
}
