package com.huimv.eartag2.api.service.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.mapper.EartagAbnormalAlarmMapper;
import com.huimv.eartag2.api.pojo.EartagAbnormalAlarm;
import com.huimv.eartag2.api.pojo.EartagAbnormalCount;
import com.huimv.eartag2.api.mapper.EartagAbnormalCountMapper;
import com.huimv.eartag2.api.service.EartagAbnormalCountService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-08-20
 */
@Service
public class EartagAbnormalCountServiceImpl extends ServiceImpl<EartagAbnormalCountMapper, EartagAbnormalCount> implements EartagAbnormalCountService {
    @Autowired
    private EartagAbnormalCountMapper eartagAbnormalCountMapper;
    @Autowired
    private EartagAbnormalAlarmMapper eartagAbnormalAlarmMapper;

    @Override
    public Result listAbnormalCount(Map<String, String> map) {
        String farmCode = map.get("farmId")+"";
        String addDate = map.get("addDate")+"";
        QueryWrapper<EartagAbnormalCount> wrapper = new QueryWrapper();
        wrapper.eq("farm_code",farmCode).eq("add_date",addDate);
        EartagAbnormalCount eartagAbnormalCount = eartagAbnormalCountMapper.selectOne(wrapper);
        return new Result(ResultCode.SUCCESS,eartagAbnormalCount);
    }

    @Override
    public Result listAbnoramAll(Map<String, String> map) {
        String farmId = map.get("farmId");
        String pageNo = map.get("pageNo");
        String pageSize = map.get("pageSize");
        QueryWrapper<EartagAbnormalAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_from",2);
        wrapper.eq("alarm_type",2);
        wrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        wrapper.eq("farm_code",farmId);
        wrapper.orderByDesc("id");
        Page<EartagAbnormalAlarm> eartagAbnormalAlarmPage = eartagAbnormalAlarmMapper.selectPage(new Page<EartagAbnormalAlarm>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);
        return  new Result(ResultCode.SUCCESS,eartagAbnormalAlarmPage);
    }

    @Override
    public Result listAbnoramDev(Map<String, String> map) {
        String farmId = map.get("farmId");
        String pageNo = map.get("pageNo");
        String pageSize = map.get("pageSize");
        QueryWrapper<EartagAbnormalAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_from",1);
        wrapper.eq("alarm_type",2);
        wrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        wrapper.eq("farm_code",farmId);
        wrapper.orderByDesc("id");
        Page<EartagAbnormalAlarm> eartagAbnormalAlarmPage = eartagAbnormalAlarmMapper.selectPage(new Page<EartagAbnormalAlarm>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);
        return  new Result(ResultCode.SUCCESS,eartagAbnormalAlarmPage);
    }
}
