package com.huimv.eartag2.api.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.mapper.EartagEartagRegister2Mapper;
import com.huimv.eartag2.api.mapper.SysAccountMultilevelMapper;
import com.huimv.eartag2.api.pojo.EartagData2;
import com.huimv.eartag2.api.mapper.EartagData2Mapper;
import com.huimv.eartag2.api.pojo.EartagEartagRegister2;
import com.huimv.eartag2.api.pojo.SysAccountMultilevel;
import com.huimv.eartag2.api.pojo.pojovo.EartagDataDto;
import com.huimv.eartag2.api.pojo.pojovo.QingShanData;
import com.huimv.eartag2.api.service.IEartagData2Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author author
 * @since 2022-07-29
 */
@Service
public class EartagData2ServiceImpl extends ServiceImpl<EartagData2Mapper, EartagData2> implements IEartagData2Service {

    @Resource
    private EartagData2Mapper eartagData2Mapper;

    @Resource
    private EartagEartagRegister2Mapper eartagEartagRegister2Mapper;

    @Resource
    private SysAccountMultilevelMapper sysAccountMultilevelMapper;

    @Override
    public List<EartagData2> getEartagData(String earmark) throws ParseException {
        QueryWrapper<EartagData2> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("earmark", earmark);
        List<EartagData2> eartagData2s = eartagData2Mapper.selectList(queryWrapper);

        //查询出来五分钟之内的数据;

        Calendar calendar = Calendar.getInstance();
        //1-当前时间
        Long currentTimestamps = System.currentTimeMillis();

        //存五秒内的数据
        ArrayList<EartagData2> eartagData2s1 = new ArrayList<>();
        if (null != eartagData2s && eartagData2s.size() > 0) {
            for (EartagData2 eartagData2 : eartagData2s) {
                String addTime = eartagData2.getAddTime() + "";
                calendar.setTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").parse(addTime));
                long timeInMillis = calendar.getTimeInMillis();
                if (currentTimestamps - timeInMillis <= 5000) {
                    eartagData2s1.add(eartagData2);
                }
            }
        }
        return eartagData2s1;
    }

    @Override
    public Result getEnvByTime(Map<String, String> map) {
        String earmark = map.get("earmark");
        String startDate = map.get("startDate");
        String endDate = map.get("endDate");
        String userId = map.get("userId");

        Date now = new Date();
        SysAccountMultilevel user = sysAccountMultilevelMapper.selectById(userId);

        if (StringUtils.isBlank(earmark)) {
            return new Result(10001, "请选择耳标", false);
        }
        QueryWrapper<EartagData2> wrapper = new QueryWrapper<>();
        wrapper.eq("earmark", earmark);
        if (StringUtils.isBlank(startDate)) {
            wrapper.ge("add_time", DateUtil.beginOfDay(now));
        } else {
            wrapper.between("add_time", startDate, endDate);
        }

        wrapper.orderByAsc("add_time");
        List<EartagData2> list = this.list(wrapper);


        //用户数据
//        if (user.getIsUser() == 0) {
            if (!"1".equals(userId)){

            for (EartagData2 eartagData2 : list) {
                Float earTemp1 = eartagData2.getEarTemp1();
                if (earTemp1 > 40) {
                    eartagData2.setEarTemp1(40F);
                }

                if (earTemp1 < 30) {
                    double a= new Random().nextInt(32) % (2) + 29;
                    DecimalFormat df = new DecimalFormat( "0.00" );
                    String str=df.format( a );

                    eartagData2.setEarTemp1(Float.parseFloat(str));
//                    eartagData2.setEarTemp1(30F);
                }
            }
            }
//        }

        return new Result(ResultCode.SUCCESS, list);
    }

    @Override
    public Result getEnvByTime2(Map<String, String> map) {
        String earmark = map.get("earmark");
        String startDate = map.get("startDate");
        String endDate = map.get("endDate");
//        String userId = map.get("userId");
        Date now = new Date();
//        SysAccountMultilevel user = sysAccountMultilevelMapper.selectById(userId);
        if (StringUtils.isBlank(earmark)) {
            return new Result(10001, "请选择耳标", false);
        }
        QueryWrapper<EartagData2> wrapper = new QueryWrapper<>();
        wrapper.eq("earmark", earmark);
        if (StringUtils.isBlank(startDate)) {
            wrapper.ge("add_time", DateUtil.beginOfDay(now));
        } else {
            wrapper.between("add_time", startDate, endDate);
        }
        wrapper.orderByAsc("add_time");
        List<EartagData2> list = this.list(wrapper);
        //用户数据
//        if (user.getIsUser() == 0) {
//            for (EartagData2 eartagData2 : list) {
//                Float earTemp1 = eartagData2.getEarTemp1();
//                if (earTemp1 > 40) {
//                    eartagData2.setEarTemp1(40F);
//                }
//
//                if (earTemp1 < 30) {
//                    eartagData2.setEarTemp1(30F);
//                }
//
//            }
//        }
        return new Result(ResultCode.SUCCESS, list);
    }

    @Override
    public Result getEartagDataByEarmark(Map<String, String> map) {
        String earmark = map.get("earmark");
//        String recordCount = map.get("recordCount");
        String startDate = map.get("startDate");
        String endDate = map.get("endDate");
//        List<EartagData2> eartagData2List = eartagData2Mapper.getEartagDataByEarmark(earmark, recordCount);
        QueryWrapper<EartagData2> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("earmark",earmark);
        queryWrapper.between("add_time",startDate,endDate);
        queryWrapper.orderByDesc("add_time");
        List<EartagData2> eartagData2List = eartagData2Mapper.selectList(queryWrapper);

        if (eartagData2List.size() == 0) {
            return new Result(10009, "数据为空", false);
        } else {
            List<EartagData2> newList = new ArrayList();
            for (int a = eartagData2List.size() - 1; a >= 0; a--) {
                newList.add(eartagData2List.get(a));
            }
            return new Result(ResultCode.SUCCESS, newList);
        }
    }

    @Override
    public Result getTemp(Map<String, String> map) {
        String earmark = map.get("earmark");
        return  new Result(ResultCode.SUCCESS,this.list(new QueryWrapper<EartagData2>().eq("earmark",  earmark).ge("ask_time", DateUtil.beginOfDay(new Date()))));

    }

    @Override
    public Result getAct(Map<String, String> map) {
        Date date = new Date();
        String earmark = map.get("earmark");
        QueryWrapper<EartagData2> wrapper = new QueryWrapper<>();
        wrapper.eq("earmark",earmark);
        wrapper.between("ask_time",DateUtil.beginOfDay(DateUtil.offsetDay(date,-7)),date);
        wrapper.groupBy("`time`");
        List<EartagDataDto> list =   eartagData2Mapper.getAct(wrapper);
        return new Result(ResultCode.SUCCESS,list);
    }

    @Override
    public Result countEartag(Map<String, String> map) {
        String farmCode = map.get("farmCode");
        QueryWrapper<EartagEartagRegister2> wrapper = new QueryWrapper<>();
        wrapper.eq("farm_id",farmCode);
        Long countAll = eartagEartagRegister2Mapper.selectCount(wrapper);
        wrapper.eq("live_status", 1);
        Long countOn = eartagEartagRegister2Mapper.selectCount(wrapper);


        Map endMap = new HashMap();
        endMap.put("countAll",countAll);
        endMap.put("countOn",countOn);
        endMap.put("offCount",countAll -countOn);
        endMap.put("avgTemp","0.0");
        endMap.put("envTemp","0.0");
        endMap.put("qingShanData",new ArrayList<>());
        List<QingShanData> shanDataList = eartagEartagRegister2Mapper.qingShanData(farmCode);
        if (ObjectUtil.isNotEmpty(shanDataList)){
            endMap.put("qingShanData",shanDataList);
            endMap.put("avgTemp",shanDataList.get(0).getEarTemp());
            endMap.put("envTemp",shanDataList.get(0).getEarTemp());
        }

        return new Result(ResultCode.SUCCESS,endMap);
    }

    @Override
    public Result getEnvByTimePanan(Map<String, String> map) {
        String earmark = map.get("earmark");
        String startDate = map.get("startDate");
        String endDate = map.get("endDate");

        Date now = new Date();

        if (StringUtils.isBlank(earmark)) {
            return new Result(10001, "请选择耳标", false);
        }
        QueryWrapper<EartagData2> wrapper = new QueryWrapper<>();
        wrapper.eq("earmark", earmark);
        if (StringUtils.isBlank(startDate)) {
            wrapper.ge("add_time", DateUtil.beginOfDay(now));
        } else {
            wrapper.between("add_time", startDate, endDate);
        }
        wrapper.orderByAsc("add_time");
        List<EartagData2> list = this.list(wrapper);

        return new Result(ResultCode.SUCCESS, list);
    }

    @Override
    public Result getEnvLast(Map<String, String> map) {
        String earmark = map.get("earmark");
        String quantity = map.get("quantity");
        if (StringUtils.isBlank(earmark)){
            return new Result(10001,"耳标为空",false);
        }
        if (StringUtils.isBlank(quantity)){
            quantity = "50";
        }
        List<EartagData2> eartagData2List = this.list(new QueryWrapper<EartagData2>().eq("earmark", earmark).orderByDesc("add_time").last(String.format("limit %s", quantity)));
        return new Result(ResultCode.SUCCESS,eartagData2List);
    }
}
