package com.huimv.eartag2.api.service.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.pojo.EartagData;
import com.huimv.eartag2.api.mapper.EartagDataMapper;
import com.huimv.eartag2.api.service.EartagDataService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-07-18
 */
@Service
public class EartagDataServiceImpl extends ServiceImpl<EartagDataMapper, EartagData> implements EartagDataService {

    @Override
    public Result getEnvByTime(Map<String, String> map) {
        String earmark = map.get("earmark");
        String startDate = map.get("startDate");
        String endDate = map.get("endDate");
        Date now = new Date();

        if (StringUtils.isBlank(earmark)){
            return new Result(10001,"请选择耳标",false);
        }
        QueryWrapper<EartagData> wrapper = new QueryWrapper<>();
        wrapper.eq("earmark",earmark);
        if (StringUtils.isBlank(startDate)){
//            wrapper.ge("ask_time", DateUtil.beginOfDay(now));
            wrapper.ge("add_time", DateUtil.beginOfDay(now));
        }else {
//            wrapper.between("ask_time",startDate,endDate);
            wrapper.between("add_time",startDate,endDate);
        }

        wrapper.orderByAsc("add_time");
        List<EartagData> list = this.list(wrapper);

        return new Result(ResultCode.SUCCESS,list);
    }


}
