package com.huimv.eartag2.api.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.common.utils.DateUtil;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.pojo.EartagReset;
import com.huimv.eartag2.api.mapper.EartagResetMapper;
import com.huimv.eartag2.api.service.EartagResetService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-08-12
 */
@Service
public class EartagResetServiceImpl extends ServiceImpl<EartagResetMapper, EartagReset> implements EartagResetService {
    @Autowired
    private EartagResetMapper eartagResetMapper;
    @Override
    public Result getEartagResetDetails(String farmCode, String startDate, String endDate, String earmark, int pageNo, int pageSize) throws ParseException {
        QueryWrapper<EartagReset> queryWrapper= new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(farmCode),"farm_code",farmCode);
        queryWrapper.between("add_date",startDate,endDate);
        queryWrapper.eq(StringUtils.isNotBlank(earmark),"earmark",earmark);
        queryWrapper.orderByAsc("reset_time");
        Page<EartagReset> page = new Page<>(Integer.valueOf(pageNo), Integer.valueOf(pageSize));
        Page<EartagReset> pageEartagReset = eartagResetMapper.selectPage(page,queryWrapper);
        List resultList = new ArrayList();
        DateUtil du = new DateUtil();
        List<EartagReset> eartagResetList = pageEartagReset.getRecords();
        for(EartagReset eartagReset:eartagResetList){
            Map map = new HashMap<>();
            resultList.add(map);
            map.put("addDate",du.formatDateText(eartagReset.getAddDate()));
            map.put("earmark",eartagReset.getEarmark());
            map.put("resetTime",du.formatDatetimeText(eartagReset.getResetTime()));
            map.put("lastId",eartagReset.getLastId());
            map.put("lastAct",eartagReset.getLastAct());
            map.put("act",eartagReset.getAct());
        }
        return new Result(ResultCode.SUCCESS,pageEartagReset.setRecords(resultList));
    }
}
