package com.huimv.eartag2.api.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.api.pojo.PliersDemo;
import com.huimv.eartag2.api.mapper.PliersDemoMapper;
import com.huimv.eartag2.api.service.IPliersDemoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-08-03
 */
@Service
public class PliersDemoServiceImpl extends ServiceImpl<PliersDemoMapper, PliersDemo> implements IPliersDemoService {

    @Override
    public Result listByPliersId(Map<String,String> map) {
        String pageSize = map.get("pageSize");
        String pageNo = map.get("pageNo");
        String deviceCode = map.get("deviceCode");
        String earmark = map.get("earmark");
        QueryWrapper<PliersDemo> wrapper = new QueryWrapper<>();
        wrapper.eq("pliers_id",deviceCode).orderByDesc("id");
        wrapper.eq(StringUtils.isNotBlank(earmark),"earmark",earmark);
        Page<PliersDemo> page = this.page(new Page<>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);

        return new Result(ResultCode.SUCCESS,page);
    }
}
