package com.huimv.eartag2.common.dao.entity;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;

@Entity
@Table(name = "eartag_data")
public class EartagDataEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    @Column(name = "cmd_header")
    private String cmdHeader;

    @Column(name = "device")
    private String device;

    @Column(name = "earmark")
    private String earmark;

    @Column(name = "bat")
    private Integer bat;

    @Column(name = "ear_temp")
    private Integer earTemp;

    @Column(name = "ear_temp1")
    private Float earTemp1;

    @Column(name = "env_temp")
    private Integer envTemp;

    @Column(name = "env_temp1")
    private Float envTemp1;

    @Column(name = "act")
    private Integer act;

    @Column(name = "act1")
    private Integer act1;

    @Column(name = "signal1")
    private Integer signal1;

    @Column(name = "ask_time")
    private String askTime;

    @Column(name = "other")
    private String other;

    @Column(name = "add_time")
    private Timestamp addTime;

    @Column(name = "create_date")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createDate;

    @Column(name = "farm_id")
    private String farmId;

    @Column(name = "ask_date")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date askDate;

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setCmdHeader(String cmdHeader) {
        this.cmdHeader = cmdHeader;
    }

    public String getCmdHeader() {
        return cmdHeader;
    }

    public void setDevice(String device) {
        this.device = device;
    }

    public String getDevice() {
        return device;
    }

    public void setEarmark(String earmark) {
        this.earmark = earmark;
    }

    public String getEarmark() {
        return earmark;
    }

    public void setBat(Integer bat) {
        this.bat = bat;
    }

    public Integer getBat() {
        return bat;
    }

    public void setEarTemp(Integer earTemp) {
        this.earTemp = earTemp;
    }

    public Integer getEarTemp() {
        return earTemp;
    }

    public void setEarTemp1(Float earTemp1) {
        this.earTemp1 = earTemp1;
    }

    public Float getEarTemp1() {
        return earTemp1;
    }

    public void setEnvTemp(Integer envTemp) {
        this.envTemp = envTemp;
    }

    public Integer getEnvTemp() {
        return envTemp;
    }

    public void setEnvTemp1(Float envTemp1) {
        this.envTemp1 = envTemp1;
    }

    public Float getEnvTemp1() {
        return envTemp1;
    }

    public void setAct(Integer act) {
        this.act = act;
    }

    public Integer getAct() {
        return act;
    }

    public void setAct1(Integer act1) {
        this.act1 = act1;
    }

    public Integer getAct1() {
        return act1;
    }

    public void setSignal1(Integer signal1) {
        this.signal1 = signal1;
    }

    public Integer getSignal1() {
        return signal1;
    }

    public void setAskTime(String askTime) {
        this.askTime = askTime;
    }

    public String getAskTime() {
        return askTime;
    }

    public void setOther(String other) {
        this.other = other;
    }

    public String getOther() {
        return other;
    }

    public void setAddTime(Timestamp addTime) {
        this.addTime = addTime;
    }

    public Timestamp getAddTime() {
        return addTime;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setFarmId(String farmId) {
        this.farmId = farmId;
    }

    public String getFarmId() {
        return farmId;
    }

    public void setAskDate(Date askDate) {
        this.askDate = askDate;
    }

    public Date getAskDate() {
        return askDate;
    }

    @Override
    public String toString() {
        return "EartagDataEntity{" +
                "id=" + id + '\'' +
                "cmdHeader=" + cmdHeader + '\'' +
                "device=" + device + '\'' +
                "earmark=" + earmark + '\'' +
                "bat=" + bat + '\'' +
                "earTemp=" + earTemp + '\'' +
                "earTemp1=" + earTemp1 + '\'' +
                "envTemp=" + envTemp + '\'' +
                "envTemp1=" + envTemp1 + '\'' +
                "act=" + act + '\'' +
                "act1=" + act1 + '\'' +
                "signal1=" + signal1 + '\'' +
                "askTime=" + askTime + '\'' +
                "other=" + other + '\'' +
                "addTime=" + addTime + '\'' +
                "createDate=" + createDate + '\'' +
                "farmId=" + farmId + '\'' +
                "askDate=" + askDate + '\'' +
                '}';
    }
}
