package com.huimv.eartag2.common.dao.entity;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;

@Entity
@Table(name = "eartag_device_register")
public class EartagDeviceRegisterEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    @Column(name = "device_code")
    private String deviceCode;

    @Column(name = "chip_id")
    private String chipId;

    @Column(name = "county_code")
    private String countyCode;

    @Column(name = "county_name")
    private String countyName;

    @Column(name = "farm_id")
    private String farmId;

    @Column(name = "farm_name")
    private String farmName;

    @Column(name = "type_f")
    private Integer typeF;

    @Column(name = "stage")
    private Integer stage;

    @Column(name = "pigpen_id")
    private Integer pigpenId;

    @Column(name = "unit_id")
    private Integer unitId;

    @Column(name = "register_time")
    private Timestamp registerTime;

    @Column(name = "last_time")
    private Timestamp lastTime;

    @Column(name = "active_status")
    private Integer activeStatus;

    @Column(name = "active_time")
    private Timestamp activeTime;

    @Column(name = "device_status", nullable = false)
    private Integer deviceStatus;

    @Column(name = "device_alias")
    private String deviceAlias;

    @Column(name = "location")
    private String location;

    @Column(name = "remark")
    private String remark;

    @Column(name = "create_date")
    private Date createDate;

    @Column(name = "update_type")
    private String updateType;

    @Column(name = "sync_Time")
    private Timestamp syncTime;

    @Column(name = "device_type")
    public Integer deviceType;

    @Column(name = "imei")
    public String imei;

    @Column(name = "upgrade")
    public Integer upgrade;

    @Column(name = "farmer_id")
    public Integer farmerId;

    @Column(name = "farmer_name")
    public String farmerName;

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setDeviceCode(String deviceCode) {
        this.deviceCode = deviceCode;
    }

    public String getDeviceCode() {
        return deviceCode;
    }

    public void setChipId(String chipId) {
        this.chipId = chipId;
    }

    public String getChipId() {
        return chipId;
    }

    public void setCountyCode(String countyCode) {
        this.countyCode = countyCode;
    }

    public String getCountyCode() {
        return countyCode;
    }

    public void setCountyName(String countyName) {
        this.countyName = countyName;
    }

    public String getCountyName() {
        return countyName;
    }

    public void setFarmId(String farmId) {
        this.farmId = farmId;
    }

    public String getFarmId() {
        return farmId;
    }

    public void setFarmName(String farmName) {
        this.farmName = farmName;
    }

    public String getFarmName() {
        return farmName;
    }

    public void setTypeF(Integer typeF) {
        this.typeF = typeF;
    }

    public Integer getTypeF() {
        return typeF;
    }

    public void setStage(Integer stage) {
        this.stage = stage;
    }

    public Integer getStage() {
        return stage;
    }

    public void setPigpenId(Integer pigpenId) {
        this.pigpenId = pigpenId;
    }

    public Integer getPigpenId() {
        return pigpenId;
    }

    public void setUnitId(Integer unitId) {
        this.unitId = unitId;
    }

    public Integer getUnitId() {
        return unitId;
    }

    public void setRegisterTime(Timestamp registerTime) {
        this.registerTime = registerTime;
    }

    public Timestamp getRegisterTime() {
        return registerTime;
    }

    public void setLastTime(Timestamp lastTime) {
        this.lastTime = lastTime;
    }

    public Timestamp getLastTime() {
        return lastTime;
    }

    public void setActiveStatus(Integer activeStatus) {
        this.activeStatus = activeStatus;
    }

    public Integer getActiveStatus() {
        return activeStatus;
    }

    public void setActiveTime(Timestamp activeTime) {
        this.activeTime = activeTime;
    }

    public Timestamp getActiveTime() {
        return activeTime;
    }

    public void setDeviceStatus(Integer deviceStatus) {
        this.deviceStatus = deviceStatus;
    }

    public Integer getDeviceStatus() {
        return deviceStatus;
    }

    public void setDeviceAlias(String deviceAlias) {
        this.deviceAlias = deviceAlias;
    }

    public String getDeviceAlias() {
        return deviceAlias;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getLocation() {
        return location;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getRemark() {
        return remark;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setUpdateType(String updateType) {
        this.updateType = updateType;
    }

    public String getUpdateType() {
        return updateType;
    }

    public void setSyncTime(Timestamp syncTime) {
        this.syncTime = syncTime;
    }

    public Timestamp getSyncTime() {
        return syncTime;
    }

    public Integer getDeviceType() {
        return deviceType;
    }

    public void setDeviceType(Integer deviceType) {
        this.deviceType = deviceType;
    }

    public String getImei() {
        return imei;
    }

    public void setImei(String imei) {
        this.imei = imei;
    }

    public Integer getUpgrade() {
        return upgrade;
    }

    public void setUpgrade(Integer upgrade) {
        this.upgrade = upgrade;
    }

    public Integer getFarmerId() {
        return farmerId;
    }

    public void setFarmerId(Integer farmerId) {
        this.farmerId = farmerId;
    }

    public String getFarmerName() {
        return farmerName;
    }

    public void setFarmerName(String farmerName) {
        this.farmerName = farmerName;
    }

    @Override
    public String toString() {
        return "EartagDeviceRegisterEntity{" +
                "id=" + id +
                ", deviceCode='" + deviceCode + '\'' +
                ", chipId='" + chipId + '\'' +
                ", countyCode='" + countyCode + '\'' +
                ", countyName='" + countyName + '\'' +
                ", farmId='" + farmId + '\'' +
                ", farmName='" + farmName + '\'' +
                ", typeF=" + typeF +
                ", stage=" + stage +
                ", pigpenId=" + pigpenId +
                ", unitId=" + unitId +
                ", registerTime=" + registerTime +
                ", lastTime=" + lastTime +
                ", activeStatus=" + activeStatus +
                ", activeTime=" + activeTime +
                ", deviceStatus=" + deviceStatus +
                ", deviceAlias='" + deviceAlias + '\'' +
                ", location='" + location + '\'' +
                ", remark='" + remark + '\'' +
                ", createDate=" + createDate +
                ", updateType='" + updateType + '\'' +
                ", syncTime=" + syncTime +
                ", deviceType=" + deviceType +
                ", imei='" + imei + '\'' +
                ", upgrade=" + upgrade +
                ", farmerId=" + farmerId +
                ", farmerName='" + farmerName + '\'' +
                '}';
    }
}
