package com.huimv.eartag2.common.dao.repo;

import com.huimv.eartag2.common.dao.entity.BasePigpenEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface BasePigpenEntityRepo extends JpaRepository<BasePigpenEntity, Integer>, JpaSpecificationExecutor<BasePigpenEntity> {
    @Query(nativeQuery=true, value="SELECT * FROM base_pigpen WHERE id IN(?1,?2)")
    public abstract List<BasePigpenEntity> getPigpenByPigpenIdAndUnitId(Integer paramInteger1, Integer paramInteger2);

    @Query(nativeQuery=true, value="SELECT temp.pigpen_name,p2.pigpen_name unit_name FROM (SELECT r.unit_id,p.pigpen_name FROM eartag_device_register r LEFT JOIN base_pigpen p ON r.pigpen_id=p.id WHERE device_code=?1) temp LEFT JOIN base_pigpen p2 ON temp.unit_id=p2.id")
    List<Object[]> getPigpenByDevice(String device);
}