package com.huimv.eartag2.common.dao.repo;

import com.huimv.eartag2.common.dao.entity.SysBaseConfigEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Optional;

public interface SysBaseConfigEntityRepo extends JpaRepository<SysBaseConfigEntity, Integer>, JpaSpecificationExecutor<SysBaseConfigEntity> {

    @Query(nativeQuery = true,value = "SELECT * FROM sys_base_config WHERE config_key=?1")
    Optional<SysBaseConfigEntity> getConfigValue(String timeDifference);

    @Query(nativeQuery = true,value = "SELECT b.* FROM sys_base_config a LEFT JOIN sys_base_config b ON a.row_id=b.row_id WHERE a.config_value=?2 AND b.config_key=?1")
    List<SysBaseConfigEntity> getConfigValue(String eartagMaxTem, String farmCode);

    @Query(nativeQuery = true,value = "SELECT b.*,a.config_value farm_code FROM sys_base_config a LEFT JOIN sys_base_config b ON a.row_id=b.row_id WHERE (a.config_value=?2 OR a.config_value=?3) AND b.config_key=?1")
    List<Object[]> getConfigValue(String eartagMaxTem, String farmCode,String defaultFarmCode);
//    Optional<List<SysBaseConfigEntity>> getConfigValue(String eartagMaxTem, String farmCode,String defaultFarmCode);

    @Query(nativeQuery = true,value = "SELECT b.*,a.config_value farm_code FROM sys_base_config a LEFT JOIN sys_base_config b ON a.row_id=b.row_id WHERE a.config_value=?2 AND b.config_key=?1")
    List<Object[]> getConfigValue2(String eartagMaxTem, String farmCode);

}