package com.huimv.eartag2.device.service;

import com.huimv.eartag2.common.dao.entity.*;

import java.text.ParseException;
import java.util.Map;

public interface ICacheService {
    //证是否存在当天总状态数据
    Boolean isExistTodayFarmAllStatus(String deviceCode) throws ParseException;

    //
    Object getFarmIdByDeviceCode(String deviceCode);

    //
    Object getCreateDateByFarmId(String farmId);

    //
    void putFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity) throws ParseException;

    //
    void putAllFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity) throws ParseException;

    //
    void flashAllStatusCache(String farmId, EartarFarmAllStatusEntity farmAllStatusEntity);

    //判断是否在线状态
    boolean isExistDeviceOnlineSet(String farmId, String deviceCode, String todayDateText);

    //将deviceCode加入到在线缓存当中
    void putDeviceToOnlineSet(String farmId, String deviceCode, String todayDateText);

    //
    void putDeviceRegister(String deviceCode, EartagDeviceRegisterEntity deviceRegisterEntity);

    //将设备数据保存到在线数据中
    void putDeviceInOnline(String deviceCode, EartagDeviceOnlineEntity eartagDeviceOnlineEntity);

    //
    boolean isExistEartagOnlineSet(String farmId, String earmark, String todayDateText);


    void putEartagToOnlineInSet(String farmId, String earmark, String todayDateText) throws ParseException;

    //从缓存读取在线耳标数量
    Integer getEartagOnlineTotalFromCache(String farmId, String todayDateText);

    //更新耳标注册消息缓存
    void putEartagRegister(String earmark, EartagEartagRegisterEntity eartagRegisterEntity);

    //更新耳标在线统计
    void putEartagOnlineCount(String earmark, EartagEartagOnlineEntity eartagOnlineEntity);

    //读取设备总数
    Integer getDeviceTotal(String farmId);

    void putDeviceTotal(Integer total, String farmId);

    //读取设备取消数量
    Integer getDeviceCancel(String farmId);

    //设置设备取消缓存
    void putDeviceCancel(Integer total, String farmId);

    //读取耳标总数
    Integer getEartagTotal(String farmId);

    //设置耳标总数缓存
    void putEartagTotal(Integer total, String farmId);

    //获取在线设备数量
    Integer getDeviceOnlineSum(String farmId, String todayDateText);

    //读取全部注册信息
    Map<Object, Object> getHashEntries(String deviceCode);

    //读取属性
    Object getHashProperty(String deviceCode, String deviceAlias);

    //
    void deleteDeviceToOnlineSet(String farmId, String deviceCode, String todayDateText);

    //获取环境温度的高低温阈值
    Object getEnvTempThresholdVal(String farmId);
}
