package com.huimv.eartag2.device.service;

import com.alibaba.fastjson.JSONObject;

import java.sql.Date;
import java.sql.Timestamp;
import java.text.ParseException;
import java.util.Map;

public interface IDeviceService {
    void remoteProcessFarmAllStatus(String farmId) throws ParseException;

    //保存心跳数据
    void saveDeviceHeartbeat(JSONObject dataJo, Date todayDate);
    //保存设备温度数据
    void saveDeviceTemp(JSONObject dataJo, Date todayDate, Timestamp nowTimestamp) throws ParseException;
    //保存采集器上传的原始数据
    void saveRawdata(String askText) throws ParseException;

    //处理设备心跳数据
    void handleDeviceHeartbeat(JSONObject dataJo) throws ParseException;

    //处理设备环境温度数据
    void handleDeviceEnvtemp(JSONObject dataJo) throws ParseException;

    //更新设备环境信息
    void updateEnvtempOfDeviceAllStatus(String farmId, String todayDateText, Date todayDate, Timestamp nowTimestamp) throws ParseException;

    //根据设备编码获取牧场id
    String getFarmIdByDeviceCode(String deviceCode);

    //
    void countEffectiveDeviceTotal(JSONObject deviceRegisterJo);

    //
    void countFarmAllStatus(JSONObject deviceRegisterJo) throws ParseException;

    //
    void countEffectiveDeviceTotal(Map inMap);

    //
    void cancelFarmAllStatus(Map map) throws ParseException;

    //
    void cancelDeviceOnlineLiveStatus(Map map, String todayDateText);

    //
    void unCancelDeviceOnlineLiveStatus(JSONObject deviceRegisterJo, String todayDateText);
}
