package com.huimv.eartag2.eartag.config;

import com.huimv.eartag2.common.mq.Const;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.core.TopicExchange;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Configuration
public class TopicRabbitMQConfig {
    //心跳
    @Bean
    public Queue heartbeatQueue() {
        return new Queue(Const.QUEUE_DEVICE_HEARTBEAT);
    }
    //采集器温度
//    @Bean
//    public Queue deviceTempQueue() {
//        return new Queue(Const.QUEUE_DEVICE_TEMP);
//    }
    //耳标数据
//    @Bean
//    public Queue eartagQueue() {
//        return new Queue(Const.QUEUE_EARTAG);
//    }

    //采集器设备交换机
    TopicExchange deviceExchange() {
        return new TopicExchange(Const.EXCHANGE_DEVICE);
    }

    //耳标交换机
//    TopicExchange eartagExchange() {
//        return new TopicExchange(Const.EXCHANGE_EARTAG);
//    }

    //设备交换机、心跳队列、心跳路由键绑定
    @Bean
    Binding bindingHeartbeatExchangeMessage() {
        return BindingBuilder.bind(heartbeatQueue()).to(deviceExchange()).with(Const.ROUTING_KEY_DEVICE_HEARTBEAT);
    }
    //设备交换机、设备环境温度队列、设备环境路由键绑定
//    @Bean
//    Binding bindingDeviceTempExchangeMessage() {
//        return BindingBuilder.bind(deviceTempQueue()).to(deviceExchange()).with(Const.ROUTING_KEY_DEVICE_TEMP);
//    }
    //耳标交换机、耳标队列、耳标路由键绑定
//    @Bean
//    Binding bindingEartagExchangeMessage() {
//        return BindingBuilder.bind(eartagQueue()).to(eartagExchange()).with(Const.ROUTING_KEY_EARTAG);
//    }

}
