package com.huimv.eartag2.eartag.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.huimv.eartag2.common.dao.entity.*;
import com.huimv.eartag2.common.dao.repo.*;
import com.huimv.eartag2.common.service.IBaseConfigService;
import com.huimv.eartag2.common.utils.BizConst;
import com.huimv.eartag2.common.utils.DateUtil;
import com.huimv.eartag2.eartag.service.ICacheService;
import com.huimv.eartag2.eartag.service.IDeviceService;
import com.huimv.eartag2.eartag.service.IEartagService;
//import com.huimv.eartag2.manage2.mapper.EartagData2Mapper;
//import com.huimv.eartag2.manage2.pojo.EartagData2;
//import com.huimv.eartag2.manage2.service.IEartagData2Service;
import com.huimv.eartag2.eartag.vo.EartagVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.text.ParseException;
import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class EartagServiceImpl implements IEartagService {
    //    @Resource
//    private IEartagData2Service eartagData2Service;
//    @Resource
//    private  EartagData2Mapper eartagData2Mapper;
    @Autowired
    private RedisTemplate redisTemplate;
    @Autowired
    private EartagDataRepo eartagDataRepo;
    @Autowired
    private EartagData2EntityRepo eartagData2Repo;
    @Autowired
    private ICacheService cacheService;
    @Autowired
    private IDeviceService deviceService;
    @Autowired
    private EartagEartagRegisterRepo eartagRegisterRepo;
    @Autowired
    private EartagEartagOnlineRepo eartagOnlineRepo;
    @Autowired
    private EartarFarmAllStatusRepo farmAllStatusRepo;
    @Autowired
    private EartarFarmAllStatusRepo eartagFarmAllStatusRepo;
    @Autowired
    private EartagDeviceEartagCountRepo deviceEartagCountRepo;
    @Autowired
    private EartagDeviceRegisterRepo deviceRegisterRepo;
    @Autowired
    private EartagDeviceOnlineRepo eartagDeviceOnlineRepo;
    @Autowired
    private EartagData2EntityRepo eartagData2EntityRepo;
    @Autowired
    private SysBaseConfigEntityRepo sysBaseConfigEntityRepo;
    @Autowired
    private EartagEartagRegister2EntityRepo eartagEartagRegister2EntityRepo;
    @Autowired
    private EartagOnlineStatusEntityRepo eartagOnlineStatusEntityRepo;
    @Autowired
    private EartagHourActEntityRepo eartagHourActEntityRepo;
    @Autowired
    private EartagResetEntityRepo eartagResetEntityRepo;
    @Autowired
    private EartagResetCountEntityRepo eartagResetCountEntityRepo;
    @Autowired
    private EartagAbnormalAlarmEntityRepo eartagAbnormalAlarmEntityRepo;
    @Autowired
    private EartagAbnormalCountEntityRepo eartagAbnormalCountEntityRepo;
//    @Value("${alarm.maxTemp}")
//    private String defaultMaxTemp;
//    @Value("${alarm.minTemp}")
//    private String defaultMinTemp;
    @Autowired
    private IBaseConfigService iBaseConfigService;
    @Autowired
    private BasePigpenEntityRepo basePigpenRepo;
    @Autowired
    private BizBaseStageEntityRepo bizBaseStageRepo;
    @Autowired
    private BaseFarmRepo baseFarmRepo;
    @Autowired
    private RestTemplate restTemplate;

    @Override
    public void handleEartag(JSONObject dataJo) throws ParseException {
        //设备编码
        String deviceCode = dataJo.getString("device");
        //耳标号
        String earmark = dataJo.getString("earmark");
        //电量
        String bat = dataJo.getString("bat");
        //运动量
        String act1 = dataJo.getString("act1");
        String todayDateText = new DateUtil().getTodayDateText();
        java.sql.Date todayDate = new java.sql.Date(new java.util.Date().getTime());
        Timestamp nowTimestamp = new Timestamp(new java.util.Date().getTime());
        //--设备在线统计表
        //--设备状态每日统计表
        //--设备和耳标总状态表
        //获取牧场id
        String farmId = deviceService.getFarmIdByDeviceCode(deviceCode);
        System.out.println("####### farmId=" + farmId);
        if (farmId != null) {
            //{计算小时运动量}
            countHourAct(dataJo, nowTimestamp, todayDate, farmId);

            //{保存耳标流水(所有耳标数据，可能重复上传)}
            saveEartagFlow(dataJo, nowTimestamp, todayDate, farmId);

            //{保存耳标流水，过滤设定时间范围重复耳标上传数据}
            saveEartagFlow2(dataJo, nowTimestamp, todayDate, farmId);

            //{更新设备注册信息}
            updateDeviceRegister(deviceCode, nowTimestamp, todayDate, farmId);

            //{更新耳标注册信息}
//            updateEartagRegister(earmark, deviceCode, bat, nowTimestamp, todayDate, farmId);

            //{更新耳标注册信息}
            updateEartagRegister2(earmark, deviceCode, bat, nowTimestamp, todayDate, farmId, dataJo);

            //--农户耳标注册
            updateEartagRegisterForFarmer(earmark, deviceCode, bat, nowTimestamp, todayDate, farmId, dataJo);

            //{更新设备在线统计}
            updateDeviceOnline(earmark, deviceCode, todayDateText, nowTimestamp, todayDate, dataJo, farmId);

            //{更新耳标在线统计}
            updateEartagOnline(earmark, deviceCode, todayDateText, todayDate, nowTimestamp, dataJo, farmId);

            //{更新耳标连线状态}
            updateEartagLiveStatus(earmark, deviceCode, todayDateText, todayDate, nowTimestamp, dataJo, farmId);

            //{更新耳标设备在线关联统计}
            updateEartagDeviceOnlineCount(earmark, deviceCode, todayDateText, todayDate, nowTimestamp, farmId);

            //{异常统计和异常报警}
//            abnormalCountAndAlarm(dataJo, todayDate, nowTimestamp, farmId);

            //判断该设备编号是否存在牧场缓存在线集合当中；
            if (!cacheService.isExistEartagOnlineSet(farmId, earmark, todayDateText)) {
                //更新总状态数据
                updateEartagPropertyOfAllStatus(farmId, todayDateText, todayDate, nowTimestamp);
                //将耳标号加入到耳标在线集合当中
                cacheService.putEartagToOnlineInSet(farmId, earmark, todayDateText);
            }
            System.out.println("## END 耳标数据。 " + new DateUtil().getTodayMissionText());
        } else {
            log.error("出错:该请求的FarmId为空.请检查该设备编码[" + deviceCode + "]是否存在FarmId.");
        }
    }

    @Override
    public void sendSowProvincePlatform(JSONObject dataJo, String askText) {
        // =====================================================================
        // 判断耳标-->采集器（基站）-->判断该牧场是否被允许发送耳标数据到省平台；
        // 调用省平台接口，发送耳标数据；
        // 省平台接口：接收数据并发送到耳标队列
        // =====================================================================
        System.out.println("处理发送到省平台的数据>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>="+dataJo);
        String earmark = dataJo.getString("earmark");
        System.out.println(">>>>>>>>>>>>>>>earmark="+earmark);
        //根据耳标查询耳标注册表
        EartagEartagRegister2Entity eartagRegister2Entity = eartagEartagRegister2EntityRepo.getOneByEarmark(earmark);
        if(eartagRegister2Entity != null){
            String farmId = eartagRegister2Entity.getFarmId();
            System.out.println("farmId>>"+farmId);
            BaseFarmEntity BaseFarmEntity = baseFarmRepo.getFarmByFarmId(farmId);
            System.out.println("是否允许发送到省平台:"+BaseFarmEntity.getProvinceStatus());
            //provinceStatus=1,表示允许将耳标数据同步到省平台
            if(BaseFarmEntity.getProvinceStatus() == 1){
                //调用省平台接口同步耳标数据过去
                System.out.println("调用省平台接口同步耳标数据过去");
                //////////////////////////////////////////////////////////////////////////////
                String url = "http://122.112.224.199:9501/syncEartag";
                System.out.println("## url>>"+url);
                EartagVo eartagVo = new EartagVo();
                eartagVo.setEartag(askText);
                eartagVo.setData(dataJo.toJSONString());
                restTemplate.postForObject(url,eartagVo,String.class);
            }
        }

    }

    //--农户耳标注册
    private void updateEartagRegisterForFarmer(String earmark, String deviceCode, String bat, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId, JSONObject eartagJo) {
        System.out.println(" ============================ 更新农户耳标数据 ============================ ");
        //# 判断耳标注册表是否存在；
        //      如果不存在就注册耳标；
        //      如果存在就更新活动状态（active_status）和活动状态更新时间（active_time）
        Integer registerType = 1;
        Integer activeStatus = 1;
        Integer liveStatus = 1;        //
        EartagEartagRegister2Entity eartagRegisterEntity = eartagEartagRegister2EntityRepo.getOneByEarmark2(earmark);
        if (eartagRegisterEntity == null) {
            //{新建耳标注册信息}
            //--For农户
            newEartagRegisterForFarmer(earmark, nowTimestamp, deviceCode, registerType, activeStatus, liveStatus, bat, todayDate, farmId, eartagJo);
        } else {
            eartagRegisterEntity.setLastTime(nowTimestamp);
            eartagRegisterEntity.setLastDevice(deviceCode);
            eartagRegisterEntity.setActiveStatus(activeStatus);
            eartagRegisterEntity.setActiveTime(nowTimestamp);
            eartagRegisterEntity.setBat(Integer.parseInt(bat));
            eartagRegisterEntity.setEarTemp1(eartagJo.getFloat("earTemp1"));
            eartagRegisterEntity.setEnvTemp1(eartagJo.getFloat("envTemp1"));
//            eartagRegisterEntity.setAct(Integer.parseInt(eartagJo.getString("act1")));
            eartagRegisterEntity.setSignal1(Integer.parseInt(eartagJo.getString("signal")));
            eartagRegisterEntity.setAskTime(getAskTime(eartagJo.getString("askTime")));
            eartagRegisterEntity.setOther(eartagJo.getString("other"));
            eartagRegisterEntity.setFarmId(farmId);
            eartagRegisterEntity.setLiveStatus(1);
            eartagEartagRegister2EntityRepo.saveAndFlush(eartagRegisterEntity);
            //更新耳标注册消息缓存
            cacheService.putEartagRegister(earmark, eartagRegisterEntity);
        }
    }

    //--农户
    private void newEartagRegisterForFarmer(String earmark, Timestamp nowTimestamp, String deviceCode, Integer registerType, Integer activeStatus, Integer liveStatus, String bat, java.sql.Date todayDate, String farmId, JSONObject eartagJo) {
        //#创建耳标注册记录#
        EartagEartagRegister2Entity newEartagRegisterEntity = new EartagEartagRegister2Entity();
        newEartagRegisterEntity.setEarmark(earmark);
        newEartagRegisterEntity.setFirstTime(nowTimestamp);
        newEartagRegisterEntity.setLastTime(nowTimestamp);
        newEartagRegisterEntity.setFirstDevice(deviceCode);
        newEartagRegisterEntity.setBelongDevice(deviceCode);
        newEartagRegisterEntity.setLastDevice(deviceCode);
        newEartagRegisterEntity.setRegisterTime(nowTimestamp);
        newEartagRegisterEntity.setRegisterType(registerType);
        newEartagRegisterEntity.setFarmId(farmId);

        newEartagRegisterEntity.setActiveStatus(activeStatus);
        newEartagRegisterEntity.setActiveTime(nowTimestamp);
        newEartagRegisterEntity.setLiveStatus(liveStatus);
        newEartagRegisterEntity.setCreateDate(todayDate);
        newEartagRegisterEntity.setBat(Integer.parseInt(bat));

        newEartagRegisterEntity.setEarTemp1(eartagJo.getFloat("earTemp1"));
        newEartagRegisterEntity.setEnvTemp1(eartagJo.getFloat("envTemp1"));
        newEartagRegisterEntity.setAct(Long.parseLong(eartagJo.getString("act1")));
        newEartagRegisterEntity.setSignal1(Integer.parseInt(eartagJo.getString("signal")));
        newEartagRegisterEntity.setAskTime(getAskTime(eartagJo.getString("askTime")));
        newEartagRegisterEntity.setOther(eartagJo.getString("other"));

        eartagEartagRegister2EntityRepo.saveAndFlush(newEartagRegisterEntity);
        //{更新耳标注册消息缓存}
        cacheService.putEartagRegister(earmark, newEartagRegisterEntity);
        //{更新耳标数量}
        cacheService.putEartagTotal(getEartagSum(farmId, liveStatus), farmId);
    }

    // 异常统计和报警
    private void abnormalCountAndAlarm(JSONObject dataJo, java.sql.Date todayDate, Timestamp nowTimestamp, String farmCode) {
        //处理异常-耳标温度警报和统计；
        handleEartempAlarmAndCount(dataJo, todayDate, nowTimestamp, farmCode);
        //--这里环境温度报警不用耳标里包含的环境温度数据，而是用采集器设备上传的报警数据
        //处理异常-环境温度警报和统计；
//        handleEnvtempAlarmAndCount(dataJo, todayDate, nowTimestamp, farmCode);
    }

    //处理异常环境温度警报和统计；
    private void handleEnvtempAlarmAndCount(JSONObject dataJo, java.sql.Date todayDate, Timestamp nowTimestamp, String farmCode) {
        String earmark = dataJo.getString("earmark");
        String device = dataJo.getString("device");
        //{读取栋舍}
        String pigpenName = getPigpenByDevice(device);
        // 获取异常耳标阈值最大值或最小值
//        Map maxAndMinMap = getMaxAndMinEnvtemp(farmCode);
        Map maxAndMinMap = getMaxAndMin2(farmCode, "envMaxTem", "envMinTem");
        BigDecimal configMaxTempBd = new BigDecimal(maxAndMinMap.get("envMaxTem").toString());
        BigDecimal configMinTempBd = new BigDecimal(maxAndMinMap.get("envMinTem").toString());
        BigDecimal envTemp1Bd = new BigDecimal(dataJo.getString("envTemp1"));
        if (envTemp1Bd.compareTo(configMaxTempBd) >= 0) {
            // 保存耳标高温报警
            EartagAbnormalAlarmEntity eartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
            eartagAbnormalAlarmEntity.setFarmCode(farmCode);
            eartagAbnormalAlarmEntity.setContent("高温警报：["+pigpenName+"]的环境温度为" + envTemp1Bd.toString() + "°，高于高温阈值" + configMaxTempBd.toString() + "°");
            //数据:2
            eartagAbnormalAlarmEntity.setAlarmType(2);
            //采集器:1
            eartagAbnormalAlarmEntity.setAlarmFrom(1);
            eartagAbnormalAlarmEntity.setAddTime(nowTimestamp);
            eartagAbnormalAlarmEntity.setAddDate(todayDate);
            //环境高温:3
            eartagAbnormalAlarmEntity.setAlarmSort(3);
            eartagAbnormalAlarmEntityRepo.saveAndFlush(eartagAbnormalAlarmEntity);
            // 高温次数记录
            saveEartagTempDataCount(todayDate, nowTimestamp, farmCode);
        } else if (configMinTempBd.compareTo(envTemp1Bd) >= 0) {
            // 保存耳标高温报警
            EartagAbnormalAlarmEntity eartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
            eartagAbnormalAlarmEntity.setFarmCode(farmCode);
            eartagAbnormalAlarmEntity.setContent("低温警报：["+pigpenName+"]的环境温度为" + envTemp1Bd.toString() + "°，低于低温阈值" + configMinTempBd.toString() + "°");
            //数据:2
            eartagAbnormalAlarmEntity.setAlarmType(2);
            //采集器:1
            eartagAbnormalAlarmEntity.setAlarmFrom(1);
            eartagAbnormalAlarmEntity.setAddTime(nowTimestamp);
            eartagAbnormalAlarmEntity.setAddDate(todayDate);
            //环境低温:4
            eartagAbnormalAlarmEntity.setAlarmSort(4);
            eartagAbnormalAlarmEntityRepo.saveAndFlush(eartagAbnormalAlarmEntity);
            //低温次数记录
            saveEartagTempDataCount(todayDate, nowTimestamp, farmCode);
        }
    }

    // 通过设备获取栋舍
    private String getPigpenByDevice(String device) {
        //根据设备读取栋舍
        List<Object[]> pigpenList = basePigpenRepo.getPigpenByDevice(device);
        if(pigpenList.size()==0){
            return "";
        }else{
            StringBuilder sb = new StringBuilder();
            for(int a=0;a<pigpenList.size();a++){
                Object[] objArray = pigpenList.get(0);
                if(sb.length()>0){
                    sb.append(",");
                }
                sb.append(objArray[0]).append(",").append(objArray[1]);
            }
            return sb.toString();
        }
    }

    //获取最大值
//    private Map getMaxAndMinEnvtemp(String farmCode) {
//        Map configMap = new HashMap();
//        String hashKey = BizConst.HASH_EARTEMP_TH_PREFIX + farmCode;
//        //获取耳标温度阈值：最大值
//        String maxTemp = (String) cacheService.getHashProperty(hashKey, "envMaxTem");
//        System.out.println("redis.maxTemp=" + maxTemp);
//        if (maxTemp != null) {
//            configMap.put("envMaxTem", maxTemp);
//        } else {
//            // 从属性配置表取值
//            String maxTem = getConfigValue(farmCode, "envMaxTem");
//            System.out.println("配置属性 maxTem=" + maxTem);
//            if (maxTem == null) {
//                maxTem = defaultMaxTemp;
//                System.out.println("配置属性 defaultMaxTemp=" + defaultMaxTemp);
//            }
//            configMap.put("envMaxTem", maxTem);
//            cacheService.putHashKeyProperty(hashKey, "envMaxTem", maxTem);
//        }
//        //获取耳标温度阈值：最小值
//        String minTemp = (String) cacheService.getHashProperty(hashKey, "envMinTem");
//        System.out.println("redis.minTem=" + minTemp);
//        if (minTemp != null) {
//            configMap.put("envMinTem", minTemp);
//        } else {
//            // 从属性配置表取值
//            String minTem = getConfigValue(farmCode, "envMinTem");
//            System.out.println("配置属性 minTem=" + minTem);
//            if (minTem == null) {
//                minTem = defaultMinTemp;
//                System.out.println("配置属性 defaultMinTemp=" + defaultMinTemp);
//            }
//            configMap.put("envMinTem", minTem);
//            cacheService.putHashKeyProperty(hashKey, "envMinTem", minTem);
//        }
//        return configMap;
//    }

    //处理异常耳标温度警报和统计；
    private void handleEartempAlarmAndCount(JSONObject dataJo, java.sql.Date todayDate, Timestamp nowTimestamp, String farmCode) {
        String earmark = dataJo.getString("earmark");
        System.out.println("farmCode================"+farmCode);
        // {获取异常耳标阈值最大值或最小值}
//        Map maxAndMinMap = getMaxAndMinEartemp(farmCode);
        Map maxAndMinMap = getMaxAndMin2(farmCode, "eartagMaxTem", "eartagMinTem");
        System.out.println("maxAndMinMap>>>>>>>>>>>>>>>>>>>>>>>>>>>"+maxAndMinMap.toString());
        if (! (maxAndMinMap.get("eartagMaxTem" ) instanceof Integer)){
            return;
        }
        if (! (maxAndMinMap.get("eartagMinTem" ) instanceof Integer)){
            return;
        }
        System.out.println(ObjectUtil.isEmpty(maxAndMinMap.get("eartagMaxTem")));
        System.out.println(ObjectUtil.isEmpty(maxAndMinMap.get("eartagMinTem")));
        BigDecimal configMaxTempBd = new BigDecimal(maxAndMinMap.get("eartagMaxTem").toString());
        BigDecimal configMinTempBd = new BigDecimal(maxAndMinMap.get("eartagMinTem").toString());
        BigDecimal earTemp1Bd = new BigDecimal(dataJo.getString("earTemp1"));
        if (earTemp1Bd.compareTo(configMaxTempBd) >= 0) {
            // 保存耳标高温报警
            EartagAbnormalAlarmEntity eartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
            eartagAbnormalAlarmEntity.setFarmCode(farmCode);
            eartagAbnormalAlarmEntity.setContent("高温警报：耳标号[" + earmark + "]当前耳根温度为" + earTemp1Bd.toString() + "°，高于等于高温阈值" + configMaxTempBd.toString() + "°");
            //数据:2
            eartagAbnormalAlarmEntity.setAlarmType(2);
            //耳标:2
            eartagAbnormalAlarmEntity.setAlarmFrom(2);
            eartagAbnormalAlarmEntity.setAddTime(nowTimestamp);
            eartagAbnormalAlarmEntity.setAddDate(todayDate);
            //耳标高温:1
            eartagAbnormalAlarmEntity.setAlarmSort(1);
            eartagAbnormalAlarmEntity.setTempValue(earTemp1Bd.toString());
            eartagAbnormalAlarmEntityRepo.saveAndFlush(eartagAbnormalAlarmEntity);
            // 高温次数记录
            saveEartagTempDataCount(todayDate, nowTimestamp, farmCode);
        } else if (configMinTempBd.compareTo(earTemp1Bd) >= 0) {
            // 保存耳标高温报警
            EartagAbnormalAlarmEntity eartagAbnormalAlarmEntity = new EartagAbnormalAlarmEntity();
            eartagAbnormalAlarmEntity.setFarmCode(farmCode);
            eartagAbnormalAlarmEntity.setContent("低温警报：耳标号[" + earmark + "]当前耳根温度为" + earTemp1Bd.toString() + "°，低于等于低温阈值" + configMinTempBd.toString() + "°");
            //数据:2
            eartagAbnormalAlarmEntity.setAlarmType(2);
            //耳标:2
            eartagAbnormalAlarmEntity.setAlarmFrom(2);
            eartagAbnormalAlarmEntity.setAddTime(nowTimestamp);
            eartagAbnormalAlarmEntity.setAddDate(todayDate);
            //耳标低温:2
            eartagAbnormalAlarmEntity.setAlarmSort(2);
            eartagAbnormalAlarmEntity.setTempValue(earTemp1Bd.toString());
            eartagAbnormalAlarmEntityRepo.saveAndFlush(eartagAbnormalAlarmEntity);
            //低温次数记录
            saveEartagTempDataCount(todayDate, nowTimestamp, farmCode);
        }
    }

    // 保存异常耳标温度计数
    public void saveEartagTempDataCount(java.sql.Date todayDate, Timestamp nowTimestamp, String farmCode) {
        EartagAbnormalCountEntity eartagAbnormalCountEntity = new EartagAbnormalCountEntity();
        eartagAbnormalCountEntity.setFarmCode(farmCode);
        eartagAbnormalCountEntity.setAddDate(todayDate);
        Example<EartagAbnormalCountEntity> example = Example.of(eartagAbnormalCountEntity);
        Optional<EartagAbnormalCountEntity> optional = eartagAbnormalCountEntityRepo.findOne(example);
        if (!optional.isPresent()) {
            eartagAbnormalCountEntity.setEartagDataCount(1);
            eartagAbnormalCountEntity.setEartagDataUpateTime(nowTimestamp);
            eartagAbnormalCountEntityRepo.saveAndFlush(eartagAbnormalCountEntity);
        } else {
            EartagAbnormalCountEntity existEartagAbnormalCountEntity = optional.get();
            existEartagAbnormalCountEntity.setEartagDataCount(existEartagAbnormalCountEntity.getEartagDataCount() + 1);
            existEartagAbnormalCountEntity.setEartagDataUpateTime(nowTimestamp);
            eartagAbnormalCountEntityRepo.saveAndFlush(existEartagAbnormalCountEntity);
        }
    }

    //
//    private Map getMaxAndMinEartemp(String farmCode) {
//        Map configMap = new HashMap();
//        String hashKey = BizConst.HASH_EARTEMP_TH_PREFIX + farmCode;
//        //获取耳标温度阈值：最大值
//        String maxTemp = (String) cacheService.getHashProperty(hashKey, "eartagMaxTem");
//        System.out.println("redis.eartagMaxTem=" + maxTemp);
//        if (maxTemp != null) {
//            configMap.put("eartagMaxTem", maxTemp);
//        } else {
//            // 从属性配置表取值
//            String eartagMaxTem = getConfigValue(farmCode, "eartagMaxTem");
//            System.out.println("配置属性 eartagMaxTem=" + eartagMaxTem);
//            if (eartagMaxTem == null) {
//                eartagMaxTem = defaultMaxTemp;
////                System.out.println("默认属性 defaultMaxTemp=" + defaultMaxTemp);
//            }
//            configMap.put("eartagMaxTem", eartagMaxTem);
//            cacheService.putHashKeyProperty(hashKey, "eartagMaxTem", eartagMaxTem);
//        }
//        //获取耳标温度阈值：最小值
//        String minTemp = (String) cacheService.getHashProperty(hashKey, "eartagMinTem");
////        System.out.println("redis.eartagMinTem=" + minTemp);
//        if (minTemp != null) {
//            configMap.put("eartagMinTem", minTemp);
//        } else {
//            // 从属性配置表取值
//            String eartagMinTem = getConfigValue(farmCode, "eartagMinTem");
////            System.out.println("配置属性 eartagMinTem=" + eartagMinTem);
//            if (eartagMinTem == null) {
//                eartagMinTem = defaultMinTemp;
////                System.out.println("默认属性 defaultMinTemp=" + defaultMinTemp);
//            }
//            configMap.put("eartagMinTem", eartagMinTem);
//            cacheService.putHashKeyProperty(hashKey, "eartagMinTem", eartagMinTem);
//        }
//        return configMap;
//    }

    // 获取耳根最大最小数值
//    private Map getMaxAndMin(String farmCode, String maxKeyName, String minKeyName) {
//        Map configMap = new HashMap();
//        String hashKey = BizConst.HASH_EARTEMP_TH_PREFIX + farmCode;
//        //获取耳标温度阈值：最大值
//        String maxTemp = (String) cacheService.getHashProperty(hashKey, maxKeyName);
////        System.out.println("redis.eartagMaxTem=" + maxTemp);
//        if (maxTemp != null) {
//            configMap.put(maxKeyName, maxTemp);
//        } else {
//            // 从属性配置表取值
//            String confMaxTem = getConfigValue(farmCode, maxKeyName);
////            System.out.println("配置属性 confMaxTem=" + confMaxTem);
//            if (confMaxTem == null) {
//                confMaxTem = defaultMaxTemp;
////                System.out.println("默认属性 defaultMaxTemp=" + defaultMaxTemp);
//            }
//            configMap.put(maxKeyName, confMaxTem);
//            cacheService.putHashKeyProperty(hashKey, maxKeyName, confMaxTem);
//        }
//        //获取耳标温度阈值：最小值
//        String minTemp = (String) cacheService.getHashProperty(hashKey, minKeyName);
////        System.out.println("redis.eartagMinTem=" + minTemp);
//        if (minTemp != null) {
//            configMap.put(minKeyName, minTemp);
//        } else {
//            // 从属性配置表取值
//            String configMinTem = getConfigValue(farmCode, minKeyName);
////            System.out.println("配置属性 configMinTem=" + configMinTem);
//            if (configMinTem == null) {
//                configMinTem = defaultMinTemp;
////                System.out.println("默认属性 defaultMinTemp=" + defaultMinTemp);
//            }
//            configMap.put(minKeyName, configMinTem);
//            cacheService.putHashKeyProperty(hashKey, minKeyName, configMinTem);
//        }
//        return configMap;
//    }

    // 获取最大最小数值
    private Map getMaxAndMin2(String farmCode, String maxKeyName, String minKeyName) {
        Map configMap = new HashMap();
        String hashKey = BizConst.HASH_EARTEMP_TH_PREFIX + farmCode;
        //获取耳标温度阈值：最大值
//        String maxTemp = (String) cacheService.getHashProperty(hashKey, maxKeyName);
//        System.out.println("redis.eartagMaxTem=" + maxTemp);
//        if (maxTemp != null) {
//            configMap.put(maxKeyName, maxTemp);
//        } else {
        // 从属性配置表取值
        System.out.println("aa farmCode="+farmCode);
        System.out.println("bb maxKeyName="+maxKeyName);
        String confMaxTem = getConfigValue(farmCode, maxKeyName);
        System.out.println("配置属性 confMaxTem=" + confMaxTem);
        if (confMaxTem == null) {
//            confMaxTem = defaultMaxTemp;
//            System.out.println("默认属性 defaultMaxTemp=" + defaultMaxTemp);
            log.error("属性配置:"+maxKeyName+"未配置,请联系管理员进行配置.");
        }
        configMap.put(maxKeyName, confMaxTem);
//            cacheService.putHashKeyProperty(hashKey, maxKeyName, confMaxTem);
//        }

        //获取耳标温度阈值：最小值
//        String minTemp = (String) cacheService.getHashProperty(hashKey, minKeyName);
//        System.out.println("redis.eartagMinTem=" + minTemp);
//        if (minTemp != null) {
//            configMap.put(minKeyName, minTemp);
//        } else {
        // 从属性配置表取值
        String configMinTem = getConfigValue(farmCode, minKeyName);
//        System.out.println("配置属性 configMinTem=" + configMinTem);
        if (configMinTem == null) {
//            configMinTem = defaultMinTemp;
//            System.out.println("默认属性 defaultMinTemp=" + defaultMinTemp);
            log.error("属性配置:"+minKeyName+"未配置,请联系管理员进行配置.");
        }
        configMap.put(minKeyName, configMinTem);
//            cacheService.putHashKeyProperty(hashKey, minKeyName, configMinTem);
//        }
        return configMap;
    }

    // 从属性配置表取值
    public String getConfigValue(String farmCode, String configKey) {
        //从数据库读取温度阈值属性
//        List<SysBaseConfigEntity> configList = sysBaseConfigEntityRepo.getConfigValue(configKey, farmCode);
//        if (configList.size() > 0) {
//            SysBaseConfigEntity sysBaseConfigEntity = configList.get(0);
//            return sysBaseConfigEntity.getConfigValue();
//        } else {
//            return null;
//        }
        System.out.println(">> ================ configKey="+configKey);
        System.out.println(">> ================ farmCode="+farmCode);
        Map configMap = iBaseConfigService.getConfigValue(configKey,farmCode,"0");
        System.out.println("configMap >>>>>>>>>>>>>>>>>>>>> "+configMap);
        if(configMap == null){
            log.error("耳标离线过程丢弃数据时长属性未配置.采用默认配置参数 configKey="+configKey);
            return null;
        }else{
            return configMap.get("configValue")+"";
        }
    }

    // 计算小时运动量
    private void countHourAct(JSONObject eartagJo, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId) {
        DateUtil du = new DateUtil();
        int nowHour = du.getNowHour();
        // 小时
        int eartagOfflineTime = 24;
//        Optional<SysBaseConfigEntity> optionalConfig = sysBaseConfigEntityRepo.getConfigValue("dropDataEartagOffLineTime");
//        if (optionalConfig.isPresent()) {
//            eartagOfflineTime = Integer.parseInt(optionalConfig.get().getConfigValue());
//            log.info("耳标离线过程丢弃数据时长=" + eartagOfflineTime);
//        } else {
//            log.error("耳标离线过程丢弃数据时长属性未配置.");
//        }
        Map configMap = iBaseConfigService.getConfigValue("dropDataEartagOffLineTime",farmId,"0");
        System.out.println("configMap 11111 >>>>>>>>>>>>>>>>>>>>> "+configMap);
        if(configMap == null){
            log.error("耳标离线过程丢弃数据时长属性未配置.采用默认配置参数 eartagOfflineTime="+eartagOfflineTime);
        }else{
            eartagOfflineTime = Integer.parseInt(configMap.get("configValue")+"");
            System.out.println("eartagOfflineTime >>>>>>>>>>>> "+eartagOfflineTime);
        }
        System.out.println("2222222222222222222222222");
        String earmark = eartagJo.getString("earmark");
        Long act = Long.parseLong(eartagJo.getString("act"));
        System.out.println("本次运动量=" + act);
        System.out.println("earmark=" + earmark);
        System.out.println("farmId=" + farmId);
        //
        Optional<EartagData2Entity> optionEartagData = eartagData2Repo.getLastByEarmark(earmark, farmId);
        System.out.println("optionEartagData.isPresent=" + optionEartagData.isPresent());
        if (optionEartagData.isPresent()) {
            // 上一次耳标运动量
            EartagData2Entity eartagData2Entity = optionEartagData.get();
            int lastId = eartagData2Entity.getId();
            Long lastAct = eartagData2Entity.getAct();
            System.out.println("上次运动量=" + lastAct);
            Timestamp lastAddTime = eartagData2Entity.getAddTime();
            long timeDiff = nowTimestamp.getTime() - lastAddTime.getTime();
            if (timeDiff / (1000 * 60 * 60) < eartagOfflineTime) {
                long act1 = 0;
                boolean resetStatus = false;
                if (act < lastAct) {
                    act1 = act;
                    resetStatus = true;
                } else {
                    act1 = act - lastAct;
                }
                System.out.println("本次运动量增量=" + act1);
                //{保存耳标小时运动量}
                saveEartagHourAct(farmId, earmark, act1, nowHour, todayDate);
                //{保存耳标复位记录}
                saveEartagReset(resetStatus, farmId, earmark, nowTimestamp, todayDate, lastId, lastAct, act);
            }
        } else {
            log.info("该耳标号[" + earmark + "]无上一次耳标数据.");
            //{保存耳标小时运动量}
            saveEartagHourAct(farmId, earmark, act, nowHour, todayDate);
        }
    }

    //{保存耳标复位记录}
    private void saveEartagReset(boolean resetStatus, String farmId, String earmark, Timestamp nowTimestamp, java.sql.Date todayDate, int lastId, Long lastAct, Long act) {
        if (resetStatus) {
            // 保存复位记录
            EartagResetEntity eartagResetEntity = new EartagResetEntity();
            eartagResetEntity.setEarmark(earmark);
            eartagResetEntity.setAddDate(todayDate);
            eartagResetEntity.setResetTime(nowTimestamp);
            eartagResetEntity.setFarmCode(farmId);
            eartagResetEntity.setLastId(lastId);
            eartagResetEntity.setLastAct(lastAct);
            eartagResetEntity.setAct(act);
            eartagResetEntityRepo.save(eartagResetEntity);

            // 复位统计次数
            EartagResetCountEntity eartagResetCountEntity = new EartagResetCountEntity();
            eartagResetCountEntity.setEarmark(earmark);
            eartagResetCountEntity.setFarmCode(farmId);
            eartagResetCountEntity.setAddDate(todayDate);
            Example<EartagResetCountEntity> example = Example.of(eartagResetCountEntity);
            Optional<EartagResetCountEntity> optionEartagResetCountEntity = eartagResetCountEntityRepo.findOne(example);
            if (!optionEartagResetCountEntity.isPresent()) {
                eartagResetCountEntity.setTimes(1);
                eartagResetCountEntityRepo.save(eartagResetCountEntity);
            } else {
                EartagResetCountEntity existEartagResetCountEntity = optionEartagResetCountEntity.get();
                existEartagResetCountEntity.setTimes(existEartagResetCountEntity.getTimes() + 1);
                eartagResetCountEntityRepo.save(existEartagResetCountEntity);
            }
        }
    }

    // {保存耳标小时运动量}
    private void saveEartagHourAct(String farmId, String earmark, long act1, int nowHour, java.sql.Date todayDate) {
        Optional<EartagHourActEntity> optionalHourAct = eartagHourActEntityRepo.findByFarmIdAndEarmarkAndHourAndDate(farmId, earmark, nowHour, todayDate);
        if (!optionalHourAct.isPresent()) {
            EartagHourActEntity newEartagHourActEntity = new EartagHourActEntity();
            newEartagHourActEntity.setFarmCode(farmId);
            newEartagHourActEntity.setEarmark(earmark);
            newEartagHourActEntity.setAddDate(todayDate);
            newEartagHourActEntity.setHour(nowHour);
            newEartagHourActEntity.setAct(act1);
            eartagHourActEntityRepo.save(newEartagHourActEntity);
        } else {
            EartagHourActEntity eartagHourActEntity = optionalHourAct.get();
            eartagHourActEntity.setAct(eartagHourActEntity.getAct() + act1);
            eartagHourActEntityRepo.save(eartagHourActEntity);
        }
    }

    // 更新耳标连线状态
    private void updateEartagLiveStatus(String earmark, String deviceCode, String todayDateText, java.sql.Date todayDate, Timestamp nowTimestamp, JSONObject dataJo, String farmId) {
        // 通过耳标注册表查找耳标所属单元
        EartagEartagRegister2Entity eartagEartagRegister2Entity = eartagEartagRegister2EntityRepo.getOneByEarmark(earmark, farmId);
        if (eartagEartagRegister2Entity == null) {
            log.info("该耳标不存在（earmark=" + earmark + ",farmId=" + farmId + "）");
            return;
        }
        Integer unitId = eartagEartagRegister2Entity.getUnitId();
        Optional<EartagOnlineStatusEntity> optionEartagStatus = eartagOnlineStatusEntityRepo.findLastOne(farmId, unitId);
        if (!optionEartagStatus.isPresent()) {
            log.error("该记录不存在");
            return;
        }
        EartagOnlineStatusEntity eartagOnlineStatusEntity = optionEartagStatus.get();
//        System.out.println("onlineEarmark=" + eartagOnlineStatusEntity.getOnlineEarmark());
//        System.out.println("offlineEarmark=" + eartagOnlineStatusEntity.getOfflineEarmark());
        if (eartagOnlineStatusEntity.getOnlineEarmark().indexOf(earmark) == -1 && eartagOnlineStatusEntity.getOfflineEarmark().indexOf(earmark) == -1) {
            //新耳标（在线，离线都不包含该耳标）
            log.info("耳标连线状态统计:增加新耳标[" + earmark + "]");
            String onlineEarmark = eartagOnlineStatusEntity.getOnlineEarmark();
            if (onlineEarmark.trim().length() > 0) {
                onlineEarmark += ",";
            }
            onlineEarmark += earmark;
            eartagOnlineStatusEntity.setTotal(eartagOnlineStatusEntity.getTotal() + 1);
            eartagOnlineStatusEntity.setOnline(eartagOnlineStatusEntity.getOnline() + 1);
            eartagOnlineStatusEntity.setOnlineEarmark(onlineEarmark);
            eartagOnlineStatusEntityRepo.saveAndFlush(eartagOnlineStatusEntity);
        } else if (eartagOnlineStatusEntity.getOfflineEarmark().indexOf(earmark) != -1) {
            log.info("耳标连线状态统计:耳标离线--在线[" + earmark + "]");
            //上一次处于离线状态
            eartagOnlineStatusEntity.setOnline(eartagOnlineStatusEntity.getOnline() + 1);
            eartagOnlineStatusEntity.setOffline(eartagOnlineStatusEntity.getOffline() - 1);
            String onlineEarmark = eartagOnlineStatusEntity.getOnlineEarmark();
            if (onlineEarmark.trim().length() > 0) {
                onlineEarmark += ",";
            }
            onlineEarmark += earmark;
            eartagOnlineStatusEntity.setOnlineEarmark(onlineEarmark);
            String offlineEarmark = eartagOnlineStatusEntity.getOfflineEarmark();
            offlineEarmark = offlineEarmark.replace(offlineEarmark, "");
            eartagOnlineStatusEntity.setOfflineEarmark(offlineEarmark);
            eartagOnlineStatusEntityRepo.saveAndFlush(eartagOnlineStatusEntity);
        } else {
            log.info("耳标连线状态统计:该耳标[" + earmark + "]已经在线");
        }
    }


    /**
     * @Method : countTimesByInTime
     * @Description :
     * @Params : [earmark, nowTimestamp]
     * @Return : java.lang.Boolean
     * @Author : ZhuoNing
     * @Date : 2022/8/5
     * @Time : 14:16
     */
    public Map countTimesByInTime(String earmark, Timestamp nowTimestamp, String farmId) {
        Map countMap = new HashMap();
        //
        Optional<EartagData2Entity> optionEartagData = eartagData2Repo.getLastByEarmark(earmark, farmId);
        if (!optionEartagData.isPresent()) {
            log.info("该耳标号无数据[" + earmark + "].");
            countMap.put("countTimes", true);
            countMap.put("act", 0);
            countMap.put("fisrtStatus", true);
            return countMap;
        } else {
            EartagData2Entity eartagData2Entity = optionEartagData.get();
            Timestamp addTime = eartagData2Entity.getAddTime();
            long act = eartagData2Entity.getAct();
            long timeDifference = nowTimestamp.getTime() - addTime.getTime();
            int setTimeDiff = 5;
//            Optional<SysBaseConfigEntity> optionConfig = sysBaseConfigEntityRepo.getConfigValue("timeDifference");
//            if (optionConfig.isPresent()) {
//                setTimeDiff = Integer.parseInt(optionConfig.get().getConfigValue());
//                log.info("耳标数据过滤时间差=" + setTimeDiff);
//            } else {
//                log.error("耳标数据过滤时间差属性未配置.");
//            }
            Map configMap = iBaseConfigService.getConfigValue("timeDifference",farmId,"0");
            System.out.println("configMap 33 >>>>>>>>>>>>>>>>>>>>> "+configMap);
            if(configMap == null){
                log.error("耳标离线过程丢弃数据时长属性未配置.采用默认配置参数 setTimeDiff="+setTimeDiff);
            }else{
                setTimeDiff = Integer.parseInt(configMap.get("configValue")+"");
                System.out.println("eartagOfflineTime >>>>>>>>>>>> "+setTimeDiff);
            }
            System.out.println("333333333333333333333333333333333333333");
            countMap.put("fisrtStatus", false);
            if (timeDifference / 1000 < setTimeDiff) {
                // 同一耳标数据距上一次上传数据时间<5秒，视为被其他基站上传。
                countMap.put("countTimes", false);
                return countMap;
            } else {
                // 同一耳标数据距上一次上传数据时间>5
                countMap.put("countTimes", true);
                countMap.put("act", act);
                return countMap;
            }
        }
    }

    /**
     * @Method : updateDeviceOnline
     * @Description : 更新设备在线统计
     * @Params : [earmark, deviceCode, nowTimestamp, todayDate, farmId]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/29
     * @Time : 9:13
     */
    private void updateDeviceOnline(String earmark, String deviceCode, String todayDateText, Timestamp nowTimestamp, java.sql.Date todayDate, JSONObject dataJo, String farmId) {
        // 查询在线统计；
        // 不存在，则新建设备在线统计
        //存在，则直接更新耳标数量；
        String hashKey = BizConst.DEVICE_REGISTER_PREFIX + deviceCode;
        //计算设备别名
        String alias = (String) cacheService.getHashProperty(hashKey, "deviceAlias");
        String earTemp1 = dataJo.getString("earTemp1");
        String envTemp1 = dataJo.getString("envTemp1");

        //读取在线日期
        EartagDeviceOnlineEntity eartagDeviceOnlineEntity = eartagDeviceOnlineRepo.getDeviceOnline(deviceCode, todayDateText);
        if (eartagDeviceOnlineEntity == null) {
            Integer heartbeatTotal = 0;
            Integer envtempTotal = 0;
            Timestamp heartbeatFirstTime = null;
            Timestamp heartbeatLastTime = null;
            Timestamp envtempFirstTime = null;
            Timestamp envtempLastTime = null;
            Timestamp firstTime = nowTimestamp;
            Timestamp lastTime = nowTimestamp;
            Timestamp eartagFirstTime = nowTimestamp;
            Timestamp eartagLastTime = nowTimestamp;
            Integer eartagTotal = 1;
            Integer liveStatus = 1;
            //{新建设备在线统计并创建缓存}
            newDeviceOnline(deviceCode, alias, heartbeatTotal, envtempTotal, eartagTotal, todayDate, farmId, heartbeatFirstTime, heartbeatLastTime, envtempFirstTime, envtempLastTime, firstTime, lastTime, eartagFirstTime, eartagLastTime, earTemp1, envTemp1, liveStatus);
        } else {

            eartagDeviceOnlineEntity.setAlias(alias);
            int eartagTotal = eartagDeviceOnlineEntity.getEartagTotal();
            eartagDeviceOnlineEntity.setEartagTotal(++eartagTotal);
            eartagDeviceOnlineEntity.setEartagFirstTime(nowTimestamp);
            eartagDeviceOnlineEntity.setEartagLastTime(nowTimestamp);
            eartagDeviceOnlineEntity.setLastEartag(earTemp1);
            eartagDeviceOnlineEntity.setLastEnvtemp(envTemp1);
            if (eartagDeviceOnlineEntity.getFirstTime() == null) {
                eartagDeviceOnlineEntity.setFirstTime(nowTimestamp);
            }
            eartagDeviceOnlineEntity.setLastTime(nowTimestamp);
            eartagDeviceOnlineRepo.saveAndFlush(eartagDeviceOnlineEntity);
            //更新设备在线缓存数据
            cacheService.putDeviceInOnline(deviceCode, eartagDeviceOnlineEntity);
        }

    }

    /**
     * @Method : newDeviceOnline
     * @Description : 新建设备在线
     * @Params : [deviceCode, alias, heartbeatTotal, envtempTotal, eartagTotal, todayDate, farmId, heartbeatFirstTime, heartbeatLastTime, envtempFirstTime, envtempLastTime, firstTime, lastTime, eartagFirstTime, eartagLastTime]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/29
     * @Time : 9:44
     */
    private void newDeviceOnline(String deviceCode, String alias, Integer heartbeatTotal, Integer envtempTotal, Integer eartagTotal, java.sql.Date todayDate, String farmId, Timestamp heartbeatFirstTime, Timestamp heartbeatLastTime, Timestamp envtempFirstTime, Timestamp envtempLastTime, Timestamp firstTime, Timestamp lastTime, Timestamp eartagFirstTime, Timestamp eartagLastTime, String earTemp1, String envTemp1, Integer liveStatus) {
        EartagDeviceOnlineEntity newEartagDeviceOnlineEntity = new EartagDeviceOnlineEntity();
        newEartagDeviceOnlineEntity.setDeviceCode(deviceCode);
        newEartagDeviceOnlineEntity.setAlias(alias);
        newEartagDeviceOnlineEntity.setHeartbeatTotal(heartbeatTotal);
        ;
        newEartagDeviceOnlineEntity.setEnvtempTotal(envtempTotal);
        newEartagDeviceOnlineEntity.setEartagTotal(eartagTotal);
        newEartagDeviceOnlineEntity.setFirstTime(firstTime);
        newEartagDeviceOnlineEntity.setLastTime(lastTime);
        newEartagDeviceOnlineEntity.setLastEnvtemp(envTemp1);
        newEartagDeviceOnlineEntity.setLastEartag(earTemp1);
        newEartagDeviceOnlineEntity.setAddDate(todayDate);
        newEartagDeviceOnlineEntity.setFarmId(farmId);
        newEartagDeviceOnlineEntity.setHeartbeatFirstTime(heartbeatFirstTime);
        newEartagDeviceOnlineEntity.setHeartbeatLastTime(heartbeatLastTime);
        newEartagDeviceOnlineEntity.setEnvtempFirstTime(envtempFirstTime);
        newEartagDeviceOnlineEntity.setEnvtempLastTime(envtempLastTime);
        newEartagDeviceOnlineEntity.setEartagFirstTime(eartagFirstTime);
        newEartagDeviceOnlineEntity.setEartagLastTime(eartagLastTime);
        newEartagDeviceOnlineEntity.setLiveStatus(liveStatus);
        eartagDeviceOnlineRepo.saveAndFlush(newEartagDeviceOnlineEntity);
        //将新建的设备在线数据更新到设备在线缓存
        cacheService.putDeviceInOnline(deviceCode, newEartagDeviceOnlineEntity);
    }

    /**
     * @Method : updateDeviceRegister
     * @Description : 更新设备注册状态信息
     * @Params : [deviceCode, nowTimestamp, todayDate, farmId]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/22
     * @Time : 14:06
     */
    private void updateDeviceRegister(String deviceCode, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId) {
        System.out.println("deviceCode>>" + deviceCode);
        EartagDeviceRegisterEntity deviceRegisterEntity = deviceRegisterRepo.getDeviceRegister(deviceCode);
        System.out.println("deviceRegisterEntity>>" + deviceRegisterEntity);
        if (deviceRegisterEntity == null) {
            log.error("(updateDeviceRegister).deviceRegisterEntity=null <-- deviceCode>>" + deviceCode);
        }
        deviceRegisterEntity.setLastTime(nowTimestamp);
        deviceRegisterEntity.setActiveStatus(1);
        deviceRegisterEntity.setActiveTime(nowTimestamp);
        deviceRegisterEntity.setUpdateType("耳标");
        deviceRegisterEntity.setDeviceStatus(1);
        deviceRegisterRepo.saveAndFlush(deviceRegisterEntity);
    }

    //更新耳标设备在线次数
    private void updateEartagDeviceOnlineCount(String earmark, String deviceCode, String todayDateText, java.sql.Date todayDate, Timestamp nowTimestamp, String farmId) {
        //从缓存读取耳标关联数据
//        Map timesMap = cacheService.getEartagDeviceOnlineCountEntries(earmark,deviceCode,todayDateText);
//        System.out.println("###################### timesMap>>"+timesMap);
//        if(timesMap.size()==0){
//            System.out.println("==0");
//        }else{
//            System.out.println("!=0");
//        }
        //{读取耳标设备关联统计}
        List<EartagDeviceEartagCountEntity> deviceEartagCountEntityList = deviceEartagCountRepo.getEartagDeviceCount(earmark, deviceCode, todayDateText);
        if (deviceEartagCountEntityList.size() == 0) {
            Integer count = 1;
            //{新建耳标设备关联统计}
            newEartagDeviceCount(earmark, deviceCode, count, todayDateText, todayDate, nowTimestamp, farmId);
        } else {
            //更新次数
            EartagDeviceEartagCountEntity deviceEartagCountEntity = deviceEartagCountEntityList.get(0);
            int total = deviceEartagCountEntity.getTotal();
            ++total;
            deviceEartagCountEntity.setTotal(total);
            deviceEartagCountEntity.setUpdateTime(nowTimestamp);
            deviceEartagCountRepo.saveAndFlush(deviceEartagCountEntity);
            //缓存里计数+1
            cacheService.countEartagDeviceOnlineTimes(earmark, deviceCode, total, deviceEartagCountEntity);
        }
    }

    //新建耳标设备关联统计记录
    private void newEartagDeviceCount(String earmark, String deviceCode, Integer count, String todayDateText, java.sql.Date todayDate, Timestamp nowTimestamp, String farmId) {
        EartagDeviceEartagCountEntity newDeviceEartagCountEntity = new EartagDeviceEartagCountEntity();
        newDeviceEartagCountEntity.setDeviceCode(deviceCode);
        newDeviceEartagCountEntity.setEarmark(earmark);
        newDeviceEartagCountEntity.setTotal(count);
        newDeviceEartagCountEntity.setCreateDate(todayDate);
        newDeviceEartagCountEntity.setFarmId(farmId);
        newDeviceEartagCountEntity.setUpdateTime(nowTimestamp);
        deviceEartagCountRepo.saveAndFlush(newDeviceEartagCountEntity);
        //将数据保存到缓存中
        cacheService.putEartagDeviceOnlineCount(earmark, deviceCode, todayDateText, newDeviceEartagCountEntity);
    }

    //更新设备环境信息
    public void updateEartagPropertyOfAllStatus(String farmId, String todayDateText, java.sql.Date todayDate, Timestamp nowTimestamp) throws ParseException {
        //{获取处于工作状态的设备数量}
        Integer deviceTotal = deviceService.getDeviceTotalByFarmIdFromDeviceRegister(farmId);
        //设备在线数量
        Integer deviceOnlineSum = cacheService.getDeviceOnlineSum(farmId, todayDateText);
        //设备离线数量
        Integer deviceOfflineSum = 0;
        if (deviceTotal > deviceOnlineSum) {
            deviceOfflineSum = deviceTotal - deviceOnlineSum;
        }
        //设备在线率
        BigDecimal deviceRateBd = new BigDecimal(deviceOnlineSum).divide(new BigDecimal(deviceTotal), 1, BigDecimal.ROUND_HALF_UP);
        Float deviceOnlineRate = Float.parseFloat(deviceRateBd.toString());
        //{获取注销设备数量}
        Integer deviceCancelSum = deviceService.getDeviceCancelTotalFromDeviceRegister(farmId);
        //耳标总数量 eartagService.
        Integer eartagTotal = getEartagRegTotalByFarmId(farmId);
        System.out.println("## eartagTotal>>" + eartagTotal);
        Integer eartagOnlineSum = 0;
        Float eartagOnlineRate = 0F;
        if (eartagTotal != 0) {
            //耳标在线数量 eartagService.
            eartagOnlineSum = getEartagOnelineTotal(farmId, todayDateText);
            eartagOnlineSum++;
            //耳标在线率
            BigDecimal eartagRateBd = new BigDecimal(eartagOnlineSum).divide(new BigDecimal(eartagTotal), 1, BigDecimal.ROUND_HALF_UP);
            eartagOnlineRate = Float.parseFloat(eartagRateBd.toString());
        }
        //
        EartarFarmAllStatusEntity farmAllStatusEntity = eartagFarmAllStatusRepo.getOneByFarmIdAndCreateDate(farmId, todayDateText);
        if (farmAllStatusEntity == null) {
            //{新建设备状态记录并更新缓存cache}
            newFarmAllStatus(farmId, todayDate, nowTimestamp, deviceTotal, deviceOnlineSum, deviceOfflineSum, deviceCancelSum, deviceOnlineRate, eartagTotal, eartagOnlineSum, eartagOnlineRate);
        } else {
            //计算设备状态并更新缓存cache(在线数+1，离线数-1，计算设备在线率)
            farmAllStatusEntity.setDeviceTotal(deviceTotal);
            farmAllStatusEntity.setDeviceOnline(deviceOnlineSum);
            farmAllStatusEntity.setDeviceOffline(deviceOfflineSum);
            farmAllStatusEntity.setDeviceRate(deviceOnlineRate);
            farmAllStatusEntity.setDeviceCancel(deviceCancelSum);
            farmAllStatusEntity.setEartagTotal(eartagTotal);
            farmAllStatusEntity.setEartagOnline(eartagOnlineSum);
            farmAllStatusEntity.setEartagRate(eartagOnlineRate);
            farmAllStatusEntity.setUpdateTime(nowTimestamp);
            eartagFarmAllStatusRepo.saveAndFlush(farmAllStatusEntity);
            //{同步更新牧场总状态缓存相关字段}
            cacheService.flashAllStatusCache(farmId, farmAllStatusEntity);
        }
    }

    //# 新建总状态记录 #
    private void newFarmAllStatus(String farmId, java.sql.Date todayDate, Timestamp nowTimestamp, Integer deviceTotal, Integer deviceOnlineSum, Integer deviceOfflineSum, Integer deviceCancelSum, Float deviceOnlineRate, Integer eartagTotal, Integer eartagOnlineSum, Float eartagOnlineRate) {
        Integer liveStatus = 1;
        if (deviceService.getDeviceSum(farmId, liveStatus) == 0) {
            log.error("该牧场没有任何处于工作状态的采集器设备.");
        } else {
            //# 计算耳标总数（耳标注册表）
            EartarFarmAllStatusEntity farmAllStatusEntity = new EartarFarmAllStatusEntity();
            farmAllStatusEntity.setDeviceTotal(deviceTotal);
            farmAllStatusEntity.setDeviceOnline(deviceOnlineSum);
            farmAllStatusEntity.setDeviceOffline(deviceOfflineSum);
            farmAllStatusEntity.setDeviceRate(deviceOnlineRate);
            farmAllStatusEntity.setDeviceCancel(deviceCancelSum);
            farmAllStatusEntity.setEartagTotal(eartagTotal);
            farmAllStatusEntity.setEartagOnline(eartagOnlineSum);
            farmAllStatusEntity.setEartagRate(eartagOnlineRate);
            farmAllStatusEntity.setFarmId(farmId);
            farmAllStatusEntity.setUpdateTime(nowTimestamp);
            farmAllStatusEntity.setCreateDate(todayDate);
            eartagFarmAllStatusRepo.saveAndFlush(farmAllStatusEntity);
            //设置总状态缓存
            cacheService.flashAllStatusCache(farmId, farmAllStatusEntity);
        }
    }

    //
    public Integer getEartagOnelineTotal(String farmId, String todayDateText) {
        return cacheService.getEartagOnlineTotalFromCache(farmId, todayDateText);
    }

    //
    public Integer getEartagRegTotalByFarmId(String farmId) {
        //从缓存读取耳标总数
        Integer eartagTotal = cacheService.getEartagTotal(farmId);
        if (eartagTotal != null && eartagTotal != 0) {
            return eartagTotal;
        } else {
//            List<Object[]> eartagRegList = eartagRegisterRepo.getEartagCountByFarmId(farmId);
//            Object[] eartagRegObj = (Object[]) eartagRegList.get(0);
//            Integer total = Integer.parseInt(eartagRegObj[0].toString());
            ///
            Integer liveStatus = 1;
            //{读取处于工作状态的耳标总数}
            Integer total = getEartagSum(farmId, liveStatus);
            //设置耳标总数缓存
            cacheService.putEartagTotal(total, farmId);
            //处于工作状态的耳标总数
            return total;
        }
    }

    //计算处于不同生存状态的耳标数量
    private Integer getEartagSum(String farmId, Integer liveStatus) {
        List<Object[]> eartagRegList = eartagRegisterRepo.getEartagCountByFarmId(farmId, liveStatus);
        Object[] eartagRegObj = (Object[]) eartagRegList.get(0);
        //处于工作状态的耳标总数
        return Integer.parseInt(eartagRegObj[0].toString());
    }

    //状态更新
    public void updateEartagOfAllStatus(String earmark, String deviceCode, String todayDateText, String farmId) {
        //# 判断设备和耳标总状态表是否存在
        //      存在：更新在线耳标数量；
        //      不存在：创建状态
        EartarFarmAllStatusEntity farmAllStatusEntity = farmAllStatusRepo.getOneByFarmIdAndCreateDate(farmId, todayDateText);
        if (farmAllStatusEntity == null) {
            //#获取耳标注册数量#
            int eartagTotal = getEartagRegTotalByFarmId_1(farmId);
            //#总状态记录不存在；
            EartarFarmAllStatusEntity newFarmAllStatusEntity = new EartarFarmAllStatusEntity();
            newFarmAllStatusEntity.setEartagTotal(eartagTotal);
            newFarmAllStatusEntity.setEartagOnline(1);
            farmAllStatusRepo.saveAndFlush(newFarmAllStatusEntity);
        } else {
            //#存在；
            int total = farmAllStatusEntity.getEartagOnline();
            farmAllStatusEntity.setEartagOnline(++total);
            farmAllStatusRepo.saveAndFlush(farmAllStatusEntity);
        }
    }

    //获取耳标注册数量
    public Integer getEartagRegTotalByFarmId_1(String farmId) {
        int eartagTotal = 0;
        List<Object[]> eartagRegList = eartagRegisterRepo.getEartagCountByFarmId(farmId);
        Object[] eartagRegObj = (Object[]) eartagRegList.get(0);
        //处于工作状态的耳标总数
        return Integer.parseInt(eartagRegObj[0].toString());
    }

    //更新耳标在线数据
    public void updateEartagOnline(String earmark, String deviceCode, String todayDateText, java.sql.Date todayDate, Timestamp nowTimestamp, JSONObject eartagJo, String farmId) {
        //# 判断耳标在线统计数据是否存在
        //      存在，则更新上传记录数、最后上传时间、环境温度，耳根温度，并将上面数据更新到缓存数据中；
        //      不存在，则创建耳标在线记录，并更新到缓存数据中；
        String envTemp = eartagJo.getString("envTemp1");
        String earTemp = eartagJo.getString("earTemp1");
        String act = eartagJo.getString("act");
        Integer bat = eartagJo.getInteger("bat");
        EartagEartagOnlineEntity eartagOnlineEntity = eartagOnlineRepo.getOneByEarmarkAndFarmId(earmark, todayDateText, farmId);
        if (eartagOnlineEntity == null) {
            int total = 1;
            //{新建耳标在线记录}
            newEartagOnline(earmark, total, nowTimestamp, earTemp, envTemp, todayDate, farmId,act,bat);
        } else {
            int total = eartagOnlineEntity.getTotal();
            eartagOnlineEntity.setTotal(++total);
            eartagOnlineEntity.setLastTime(nowTimestamp);
            eartagOnlineEntity.setEnvTemp(envTemp);
            eartagOnlineEntity.setEartagTemp(earTemp);
            eartagOnlineEntity.setAct(act);
            eartagOnlineEntity.setBat(bat);
            eartagOnlineRepo.saveAndFlush(eartagOnlineEntity);
            //更新耳标在线统计
            cacheService.putEartagOnlineCount(earmark, eartagOnlineEntity);
        }
    }

    //新建耳标在线记录
    private void newEartagOnline(String earmark, int total, Timestamp nowTimestamp, String earTemp, String envTemp, java.sql.Date todayDate, String farmId, String act, Integer bat) {
        EartagEartagOnlineEntity newEartagOnlineEntity = new EartagEartagOnlineEntity();
        newEartagOnlineEntity.setEarmark(earmark);
        newEartagOnlineEntity.setTotal(total);
        newEartagOnlineEntity.setFirstTime(nowTimestamp);
        newEartagOnlineEntity.setLastTime(nowTimestamp);
        newEartagOnlineEntity.setEnvTemp(envTemp);
        newEartagOnlineEntity.setEartagTemp(earTemp);
        newEartagOnlineEntity.setAddDate(todayDate);
        newEartagOnlineEntity.setFarmId(farmId);
        newEartagOnlineEntity.setAct(act);
        newEartagOnlineEntity.setBat(bat);
        eartagOnlineRepo.saveAndFlush(newEartagOnlineEntity);
        //更新耳标在线统计
        cacheService.putEartagOnlineCount(earmark, newEartagOnlineEntity);
    }

    //更新耳标在线数据
    public void updateEartagOnline_old1(String earmark, String deviceCode, String todayDateText, java.sql.Date todayDate, Timestamp nowTimestamp, JSONObject eartagJo, String farmId) {
        //# 判断耳标在线统计数据是否存在
        //      存在，则更新上传记录数、最后上传时间、环境温度，耳根温度，并将上面数据更新到缓存数据中；
        //      不存在，则创建耳标在线记录，并更新到缓存数据中；
        //耳根温度
        String earTemp = eartagJo.getString("earTemp1");
        //环境温度
        String envTemp = eartagJo.getString("envTemp");
        EartagEartagOnlineEntity eartagOnlineEntity = eartagOnlineRepo.getOneByEarmarkAndFarmId(earmark, todayDateText, farmId);
        if (eartagOnlineEntity == null) {
            //# 不存在
            EartagEartagOnlineEntity newEartagOnlineEntity = new EartagEartagOnlineEntity();
            newEartagOnlineEntity.setEarmark(earmark);
            newEartagOnlineEntity.setTotal(1);
            newEartagOnlineEntity.setFirstTime(nowTimestamp);
            newEartagOnlineEntity.setLastTime(nowTimestamp);
            newEartagOnlineEntity.setEnvTemp(envTemp);
            newEartagOnlineEntity.setEartagTemp(earTemp);
            newEartagOnlineEntity.setAddDate(todayDate);
            newEartagOnlineEntity.setFarmId(farmId);
            eartagOnlineRepo.saveAndFlush(newEartagOnlineEntity);
            //更新耳标在线统计
            cacheService.putEartagOnlineCount(earmark, newEartagOnlineEntity);
        } else {
            //# 存在
            int total = eartagOnlineEntity.getTotal();
            eartagOnlineEntity.setTotal(++total);
            eartagOnlineEntity.setLastTime(nowTimestamp);
            eartagOnlineEntity.setEnvTemp(envTemp);
            eartagOnlineEntity.setEartagTemp(earTemp);
            eartagOnlineRepo.saveAndFlush(eartagOnlineEntity);
            //更新耳标在线统计
            cacheService.putEartagOnlineCount(earmark, eartagOnlineEntity);
        }
    }

    //更新耳标注册数据
    public void updateEartagRegister(String earmark, String deviceCode, String bat, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId) {
        EartagDeviceRegisterEntity deviceRegisterEntity = deviceRegisterRepo.getByDeviceCode(deviceCode);
        Integer unitId = deviceRegisterEntity.getUnitId();
        Integer pigpenId = deviceRegisterEntity.getPigpenId();
        Map pigpenMap = new HashMap();
        List<BasePigpenEntity> basePigpenEntityList = basePigpenRepo.getPigpenByPigpenIdAndUnitId(pigpenId, unitId);
        if (basePigpenEntityList.size() == 0) {
            log.error("栋舍不存在[" + pigpenId + "," + unitId + "].");
            return;
        }
        //-- 获取栋舍名称--//
        String pigpenName = "";
        String unitName = "";
        String stageCode = "";
        for (BasePigpenEntity basePigpenEntity : basePigpenEntityList) {
            if (basePigpenEntity.getId().equals(pigpenId)) {
                pigpenName = basePigpenEntity.getPigpenName();
                continue;
            }
            if (basePigpenEntity.getId().equals(unitId)) {
                unitName = basePigpenEntity.getPigpenName();
                stageCode = basePigpenEntity.getStageCode();
            }
        }
        System.out.println("## pigpenName=" + pigpenName);
        System.out.println("## unitName=" + unitName);
        System.out.println("## stageCode=" + stageCode);
        //-- 获取阶段名称 --//
        Optional<BizBaseStageEntity> optionalBizBaseStageEntity = bizBaseStageRepo.getStageByStageCode(stageCode);
        if (!optionalBizBaseStageEntity.isPresent()) {
            log.error("该阶段不存在.");
            return;
        }
        BizBaseStageEntity bizBaseStageEntity = optionalBizBaseStageEntity.get();
        String stageName = bizBaseStageEntity.getStageName();
        System.out.println("## stageName=" + stageName);

        //# 判断耳标注册表是否存在；
        //      如果不存在就注册耳标；
        //      如果存在就更新活动状态（active_status）和活动状态更新时间（active_time）
        Integer registerType = 1;
        Integer activeStatus = 1;
        Integer liveStatus = 1;        //
        EartagEartagRegisterEntity eartagRegisterEntity = eartagRegisterRepo.getOneByEarmark(earmark, farmId);
        if (eartagRegisterEntity == null) {
            //{新建耳标注册信息}
            newEartagRegister(earmark, nowTimestamp, deviceCode, registerType, activeStatus, liveStatus, bat, todayDate, farmId, deviceRegisterEntity);
        } else {
            eartagRegisterEntity.setLastTime(nowTimestamp);
            eartagRegisterEntity.setLastDevice(deviceCode);
            eartagRegisterEntity.setActiveStatus(activeStatus);
            eartagRegisterEntity.setActiveTime(nowTimestamp);
            eartagRegisterEntity.setBat(Integer.parseInt(bat));
            eartagRegisterEntity.setUnitId(deviceRegisterEntity.getUnitId());
            eartagRegisterEntity.setUnitName(unitName);
            eartagRegisterEntity.setPigpenId(deviceRegisterEntity.getPigpenId());
            eartagRegisterEntity.setPigpenName(pigpenName);
            eartagRegisterRepo.saveAndFlush(eartagRegisterEntity);
            //更新耳标注册消息缓存
            cacheService.putEartagRegister(earmark, eartagRegisterEntity);
        }
    }

    /**
     * @Method : updateEartagRegister2
     * @Description :
     * @Params : [earmark, deviceCode, bat, nowTimestamp, todayDate, farmId]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/8/4
     * @Time : 9:39
     */
    public void updateEartagRegister2(String earmark, String deviceCode, String bat, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId, JSONObject eartagJo) {
        System.out.println(" ============================ 更新耳标编码 ============================ ");
        EartagDeviceRegisterEntity deviceRegisterEntity = deviceRegisterRepo.getByDeviceCode(deviceCode);
        Integer unitId = deviceRegisterEntity.getUnitId();
        Integer pigpenId = deviceRegisterEntity.getPigpenId();
        List<BasePigpenEntity> basePigpenEntityList = basePigpenRepo.getPigpenByPigpenIdAndUnitId(pigpenId, unitId);
        if (basePigpenEntityList.size() == 0) {
            log.error("栋舍不存在[" + pigpenId + "," + unitId + "].");
            return;
        }
        //-- 获取栋舍名称--//
        String pigpenName = "";
        String unitName = "";
        String stageCode = "";
        for (BasePigpenEntity basePigpenEntity : basePigpenEntityList) {
            if (basePigpenEntity.getId().equals(pigpenId)) {
                pigpenName = basePigpenEntity.getPigpenName();
                continue;
            }
            if (basePigpenEntity.getId().equals(unitId)) {
                unitName = basePigpenEntity.getPigpenName();
                stageCode = basePigpenEntity.getStageCode();
            }
        }
        //-- 获取阶段名称 --//
        Optional<BizBaseStageEntity> optionalBizBaseStageEntity = bizBaseStageRepo.getStageByStageCode(stageCode);
        if (!optionalBizBaseStageEntity.isPresent()) {
            log.error("该阶段不存在[" + stageCode + "].");
            return;
        }
        System.out.println("更新耳标数据...");
        BizBaseStageEntity bizBaseStageEntity = optionalBizBaseStageEntity.get();
        String stageName = bizBaseStageEntity.getStageName();
        //# 判断耳标注册表是否存在；
        //      如果不存在就注册耳标；
        //      如果存在就更新活动状态（active_status）和活动状态更新时间（active_time）
        Integer registerType = 1;
        Integer activeStatus = 1;
        Integer liveStatus = 1;        //
        EartagEartagRegister2Entity eartagRegisterEntity = eartagEartagRegister2EntityRepo.getOneByEarmark2(earmark);
        System.out.println("earmark--> " + earmark);
        if (eartagRegisterEntity == null) {
            //{新建耳标注册信息}
            newEartagRegister2(earmark, nowTimestamp, deviceCode, registerType, activeStatus, liveStatus, bat, todayDate, farmId, eartagJo, stageCode, stageName, pigpenId, pigpenName, unitId, unitName, deviceRegisterEntity);
        } else {

            eartagRegisterEntity.setLastTime(nowTimestamp);
            eartagRegisterEntity.setLastDevice(deviceCode);
            eartagRegisterEntity.setActiveStatus(activeStatus);
            eartagRegisterEntity.setActiveTime(nowTimestamp);
            eartagRegisterEntity.setBat(Integer.parseInt(bat));
            eartagRegisterEntity.setUnitId(deviceRegisterEntity.getUnitId());
            eartagRegisterEntity.setUnitName(unitName);
            eartagRegisterEntity.setPigpenId(deviceRegisterEntity.getPigpenId());
            eartagRegisterEntity.setPigpenName(pigpenName);
            eartagRegisterEntity.setStageCode(stageCode);
            eartagRegisterEntity.setStageName(stageName);
            eartagRegisterEntity.setEarTemp1(eartagJo.getFloat("earTemp1"));
//            eartagRegisterEntity.setEnvTemp1(eartagJo.getFloat("envTemp1"));
            eartagRegisterEntity.setAct(Long.parseLong(eartagJo.getString("act1")));
            eartagRegisterEntity.setSignal1(Integer.parseInt(eartagJo.getString("signal")));
            eartagRegisterEntity.setAskTime(getAskTime(eartagJo.getString("askTime")));
            eartagRegisterEntity.setOther(eartagJo.getString("other"));
            eartagRegisterEntity.setFarmId(farmId);
            eartagRegisterEntity.setLiveStatus(1);
            System.out.println("开始更新--> " + eartagRegisterEntity);
            eartagEartagRegister2EntityRepo.saveAndFlush(eartagRegisterEntity);
            //更新耳标注册消息缓存
            cacheService.putEartagRegister(earmark, eartagRegisterEntity);
        }
    }

    //新建耳标注册信息
    private void newEartagRegister(String earmark, Timestamp nowTimestamp, String deviceCode, Integer registerType, Integer activeStatus, Integer liveStatus, String bat, java.sql.Date todayDate, String farmId, EartagDeviceRegisterEntity deviceRegisterEntity) {
        //#创建耳标注册记录#
        EartagEartagRegisterEntity newEartagRegisterEntity = new EartagEartagRegisterEntity();
        newEartagRegisterEntity.setEarmark(earmark);
        newEartagRegisterEntity.setFirstTime(nowTimestamp);
        newEartagRegisterEntity.setLastTime(nowTimestamp);
        newEartagRegisterEntity.setFirstDevice(deviceCode);
        newEartagRegisterEntity.setBelongDevice(deviceCode);
        newEartagRegisterEntity.setLastDevice(deviceCode);
        newEartagRegisterEntity.setRegisterTime(nowTimestamp);
        newEartagRegisterEntity.setRegisterType(registerType);
        newEartagRegisterEntity.setFarmId(farmId);
        newEartagRegisterEntity.setActiveStatus(activeStatus);
        newEartagRegisterEntity.setActiveTime(nowTimestamp);
        newEartagRegisterEntity.setLiveStatus(liveStatus);
        newEartagRegisterEntity.setCreateDate(todayDate);
        newEartagRegisterEntity.setBat(Integer.parseInt(bat));
        newEartagRegisterEntity.setUnitId(deviceRegisterEntity.getUnitId());
//            newEartagRegisterEntity.setUnitName();
        newEartagRegisterEntity.setPigpenId(deviceRegisterEntity.getPigpenId());
//            newEartagRegisterEntity.setPigpenName();
        eartagRegisterRepo.saveAndFlush(newEartagRegisterEntity);
        //{更新耳标注册消息缓存}
        cacheService.putEartagRegister(earmark, newEartagRegisterEntity);
        //{更新耳标数量}
        cacheService.putEartagTotal(getEartagSum(farmId, liveStatus), farmId);
    }

    //新建耳标注册信息
    private void newEartagRegister2(String earmark, Timestamp nowTimestamp, String deviceCode, Integer registerType, Integer activeStatus, Integer liveStatus, String bat, java.sql.Date todayDate, String farmId, JSONObject eartagJo, String stageCode, String stageName, Integer pigpenId, String pigpenName, Integer unitId, String unitName, EartagDeviceRegisterEntity deviceRegisterEntity) {
        //#创建耳标注册记录#
        EartagEartagRegister2Entity newEartagRegisterEntity = new EartagEartagRegister2Entity();
        newEartagRegisterEntity.setEarmark(earmark);
        newEartagRegisterEntity.setFirstTime(nowTimestamp);
        newEartagRegisterEntity.setLastTime(nowTimestamp);
        newEartagRegisterEntity.setFirstDevice(deviceCode);
        newEartagRegisterEntity.setBelongDevice(deviceCode);
        newEartagRegisterEntity.setLastDevice(deviceCode);
        newEartagRegisterEntity.setRegisterTime(nowTimestamp);
        newEartagRegisterEntity.setRegisterType(registerType);
        newEartagRegisterEntity.setFarmId(farmId);

        newEartagRegisterEntity.setActiveStatus(activeStatus);
        newEartagRegisterEntity.setActiveTime(nowTimestamp);
        newEartagRegisterEntity.setLiveStatus(liveStatus);
        newEartagRegisterEntity.setCreateDate(todayDate);
        newEartagRegisterEntity.setBat(Integer.parseInt(bat));
        newEartagRegisterEntity.setUnitId(deviceRegisterEntity.getUnitId());
        newEartagRegisterEntity.setUnitName(unitName);
        newEartagRegisterEntity.setPigpenId(deviceRegisterEntity.getPigpenId());
        newEartagRegisterEntity.setPigpenName(pigpenName);
        newEartagRegisterEntity.setStageName(stageName);
        newEartagRegisterEntity.setStageCode(stageCode);

        newEartagRegisterEntity.setEarTemp1(eartagJo.getFloat("earTemp1"));
        newEartagRegisterEntity.setEnvTemp1(eartagJo.getFloat("envTemp1"));
        newEartagRegisterEntity.setAct(Long.parseLong(eartagJo.getString("act1")));
        newEartagRegisterEntity.setSignal1(Integer.parseInt(eartagJo.getString("signal")));
        newEartagRegisterEntity.setAskTime(getAskTime(eartagJo.getString("askTime")));
        newEartagRegisterEntity.setOther(eartagJo.getString("other"));

        System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>> newEartagRegisterEntity>>" + newEartagRegisterEntity.toString());

        eartagEartagRegister2EntityRepo.saveAndFlush(newEartagRegisterEntity);
        //{更新耳标注册消息缓存}
        cacheService.putEartagRegister(earmark, newEartagRegisterEntity);
        //{更新耳标数量}
        cacheService.putEartagTotal(getEartagSum(farmId, liveStatus), farmId);
    }

    //更新耳标注册数据
    public void updateEartagRegister_old(String earmark, String deviceCode, Timestamp nowTimestamp, String farmId) {
        //# 判断耳标注册表是否存在；
        //      如果不存在就注册耳标；
        //      如果存在就更新活动状态（active_status）和活动状态更新时间（active_time）
        //
        EartagEartagRegisterEntity eartagRegisterEntity = eartagRegisterRepo.getOneByEarmark(earmark, farmId);
        if (eartagRegisterEntity == null) {
            //#创建耳标注册记录#
            EartagEartagRegisterEntity newEartagRegisterEntity = new EartagEartagRegisterEntity();
            newEartagRegisterEntity.setEarmark(earmark);
            newEartagRegisterEntity.setFirstTime(nowTimestamp);
            newEartagRegisterEntity.setLastTime(nowTimestamp);
            newEartagRegisterEntity.setFirstDevice(deviceCode);
            newEartagRegisterEntity.setBelongDevice(deviceCode);
            newEartagRegisterEntity.setLastDevice(deviceCode);
            newEartagRegisterEntity.setRegisterTime(nowTimestamp);
            newEartagRegisterEntity.setRegisterType(1);
            newEartagRegisterEntity.setFarmId(farmId);
            newEartagRegisterEntity.setActiveStatus(1);
            newEartagRegisterEntity.setActiveTime(nowTimestamp);
            newEartagRegisterEntity.setLiveStatus(1);
            eartagRegisterRepo.saveAndFlush(newEartagRegisterEntity);
            //更新耳标注册消息缓存
            cacheService.putEartagRegister(earmark, newEartagRegisterEntity);
        } else {
            eartagRegisterEntity.setActiveStatus(1);
            eartagRegisterEntity.setActiveTime(nowTimestamp);
            eartagRegisterRepo.saveAndFlush(eartagRegisterEntity);
            //更新耳标注册消息缓存
            cacheService.putEartagRegister(earmark, eartagRegisterEntity);
        }
    }

    /**
     * @Method : countAct
     * @Description : 计算act数值
     * @Params : [deviceCode, nowAct0]
     * @Return : java.lang.Integer
     * @Author : ZhuoNing
     * @Date : 2022/1/18
     * @Time : 15:25
     */
    @Override
    public Integer countAct(String earmark, String nowAct) {
        //读取hash
        Object lastActObj = cacheService.getEartagLastAct(earmark);
        cacheService.putEartagAct(earmark, nowAct);
        //
//        Object testActObj = cacheService.getEartagLastAct(earmark);
//        System.out.println("## TEST testActObj>>"+testActObj);
        if (lastActObj != null) {
            return Integer.parseInt(nowAct) - Integer.parseInt(lastActObj.toString());
        } else {
            //{初始化最新的redis记录}
//            cacheService.putEartagAct(earmark,nowAct);
            //第一次的运动量计数
//            return Integer.parseInt(nowAct) - 0;
            return 0;
            //验证刚才初始化结果
//            Object lastAct = cacheService.getEartagLastAct(earmark);
//            if (lastAct == null) {
//                log.error("#--- redis数据库有问题，请检查redis是否能正常连接 ---# ");
//                return 0;
//            }else{
//                return Integer.parseInt(lastAct.toString());
//            }
        }
    }

    /**
     * @param eartagJo
     * @param nowTimestamp
     * @param todayDate
     * @param farmId
     * @Author : ZhuoNing
     * @Date : 2022/2/9
     * @Time : 14:33
     */
    public void saveEartagFlow(JSONObject eartagJo, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId) throws ParseException {
        DateUtil dateUtil = new DateUtil();
        EartagDataEntity dataEntity = new EartagDataEntity();
        dataEntity.setCmdHeader(eartagJo.getString("cmdHeader"));
        dataEntity.setDevice(eartagJo.getString("device"));
        dataEntity.setEarmark(eartagJo.getString("earmark"));
        dataEntity.setBat(Integer.parseInt(eartagJo.getString("bat")));
        dataEntity.setEarTemp(Integer.parseInt(eartagJo.getString("earTemp")));
        dataEntity.setEarTemp1(eartagJo.getFloat("earTemp1"));
        dataEntity.setEnvTemp(Integer.parseInt(eartagJo.getString("envTemp")));
        dataEntity.setEnvTemp1(eartagJo.getFloat("envTemp1"));
        dataEntity.setAct(Integer.parseInt(eartagJo.getString("act")));
        dataEntity.setAct1(Integer.parseInt(eartagJo.getString("act1")));
        dataEntity.setSignal1(Integer.parseInt(eartagJo.getString("signal")));
        dataEntity.setAskTime(getAskTime(eartagJo.getString("askTime")));
        dataEntity.setOther(eartagJo.getString("other"));
        dataEntity.setAddTime(nowTimestamp);
        dataEntity.setCreateDate(todayDate);
        dataEntity.setFarmId(farmId);
//        dataEntity.setAskDate(new java.sql.Date(dateUtil.parseDate(getAskDate(eartagJo.getString("askTime"))).getTime()));
        eartagDataRepo.saveAndFlush(dataEntity);

        //最新的耳标数据覆盖老数据
//        cacheService.putEartagFlowToCache(dataEntity.getEarmark(), dataEntity);
    }

    /**
     * @Method : saveEartagFlow2
     * @Description :
     * @Params : [eartagJo, nowTimestamp, todayDate, farmId]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/8/5
     * @Time : 10:53
     */
    public void saveEartagFlow2(JSONObject eartagJo, Timestamp nowTimestamp, java.sql.Date todayDate, String farmId) throws ParseException {
        // 判断近五分钟内是否有耳标数据 先获取耳标号
        String earmark = eartagJo.getString("earmark");
        // {}
        Map countMap = countTimesByInTime(earmark, nowTimestamp, farmId);
        Boolean countTimes = Boolean.parseBoolean(countMap.get("countTimes").toString());
        //true:设定过滤时间内无耳标数据上传入库；false:有数据入库；
        if (countTimes) {
            long act = 0;
            long act1 = 0;
            if (Boolean.parseBoolean(countMap.get("fisrtStatus").toString())) {
                act = Integer.parseInt(eartagJo.getString("act"));
            } else {
                act = Integer.parseInt(eartagJo.getString("act"));
                long lastAct = Long.parseLong(countMap.get("act").toString());
                if (act > lastAct) {
                    act1 = act - lastAct;
                }else{
                    act1 = act;
                }
            }
            DateUtil dateUtil = new DateUtil();
            EartagData2Entity dataEntity = new EartagData2Entity();
            dataEntity.setCmdHeader(eartagJo.getString("cmdHeader"));
            dataEntity.setDevice(eartagJo.getString("device"));
            dataEntity.setEarmark(eartagJo.getString("earmark"));
            dataEntity.setBat(Integer.parseInt(eartagJo.getString("bat")));
            dataEntity.setEarTemp(Integer.parseInt(eartagJo.getString("earTemp")));
            dataEntity.setEarTemp1(eartagJo.getFloat("earTemp1"));
            dataEntity.setEnvTemp(Integer.parseInt(eartagJo.getString("envTemp")));
            dataEntity.setEnvTemp1(eartagJo.getFloat("envTemp1"));
            dataEntity.setAct(act);
            dataEntity.setAct1(act1);
            dataEntity.setSignal1(Integer.parseInt(eartagJo.getString("signal")));
            dataEntity.setAskTime(getAskTime(eartagJo.getString("askTime")));
            dataEntity.setOther(eartagJo.getString("other"));
            dataEntity.setAddTime(nowTimestamp);
            dataEntity.setCreateDate(todayDate);
            dataEntity.setFarmId(farmId);
//            dataEntity.setAskDate(new java.sql.Date(dateUtil.parseDate(getAskDate(eartagJo.getString("askTime"))).getTime()));
            eartagData2EntityRepo.saveAndFlush(dataEntity);
            //更新耳标注册表中的运动量数据
            EartagEartagRegister2Entity eartagRegister2Entity = eartagEartagRegister2EntityRepo.getOneByEarmark(earmark, farmId);
            if (eartagRegister2Entity != null) {
                eartagRegister2Entity.setAct(act1);
                eartagEartagRegister2EntityRepo.saveAndFlush(eartagRegister2Entity);
            }
            //{异常统计和异常报警}
            abnormalCountAndAlarm(eartagJo, todayDate, nowTimestamp, farmId);
            //{最新的耳标数据覆盖老数据}
            cacheService.putEartagFlowToCache(dataEntity.getEarmark(), dataEntity);
        }
    }

    //
    public String getAskTime(String askTime) {
        String newAskTime = askTime.substring(0, 4) + "-" + askTime.substring(4, 6) + "-" + askTime.substring(6, 8) + " " + askTime.substring(8, 10) + ":" + askTime.substring(10, 12) + ":" + askTime.substring(12, 14);
        return newAskTime;
    }

    public String getAskDate(String askTime) {
        return askTime.substring(0, 4) + "-" + askTime.substring(4, 6) + "-" + askTime.substring(6, 8);
    }

    /**
     * 初始化redis最新记录
     */
    private void initRedisObj(String deviceCode) {
        EartagDataEntity lastEartagDataEntity = eartagDataRepo.getLastEartagData(deviceCode);
        if (lastEartagDataEntity != null) {
            System.out.println("## lastEartagDataEntity.toString>>" + lastEartagDataEntity.toString());
            //--从数据库读取最新记录并覆盖redis
            Map<String, String> map = new HashMap<>();
            map.put("cmdHeader", lastEartagDataEntity.getCmdHeader());
            map.put("device", lastEartagDataEntity.getDevice());
            map.put("earmark", lastEartagDataEntity.getEarmark());
            map.put("bat", lastEartagDataEntity.getBat().toString());
            map.put("earTemp", lastEartagDataEntity.getEarTemp().toString());
            map.put("earTemp1", lastEartagDataEntity.getEarTemp1().toString());
            map.put("envTemp", lastEartagDataEntity.getEnvTemp().toString());
            map.put("envTemp1", lastEartagDataEntity.getEnvTemp1().toString());
            map.put("act", lastEartagDataEntity.getAct().toString());
            map.put("act1", lastEartagDataEntity.getAct1().toString());
            map.put("signal1", lastEartagDataEntity.getSignal1().toString());
            map.put("askTime", lastEartagDataEntity.getAskTime());
            map.put("other", lastEartagDataEntity.getOther());
            map.put("addTime", lastEartagDataEntity.getAddTime().toString());
            //为hash结构设置多个键值对(hmset)
            redisTemplate.opsForHash().putAll(deviceCode, map);
        }
    }
}
