package com.huimv.eartag2.config;

import com.huimv.eartag2.common.mq.Const;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.FanoutExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * 广播消息传输配置
 *
 * @author 静静
 * @since 2022-07-8
 */
@Configuration
public class FanoutRabbitMQConfig {
    /**
     *  广播同步注册设备信息队列
     */
    @Bean
    public Queue fanoutSyncDeviceQueue() {
        return new Queue(Const.QUEUE_SYNC_DEVICE_FANOUT);
    }

    /**
     * 广播同步注册设备信息交换机
     */
    @Bean
    FanoutExchange fanoutSyncDeviceExchange() {
        return new FanoutExchange(Const.EXCHANGE_SYNC_DEVICE_FANOUT);
    }

    @Bean
    Binding fanoutBindingSyncDeviceExchangeMessage(){
        return BindingBuilder.bind(fanoutSyncDeviceQueue()).to(fanoutSyncDeviceExchange());
    }

}
