package com.huimv.eartag2.server;

import com.alibaba.fastjson.JSONArray;
import com.huimv.eartag2.common.mq.Const;
import com.huimv.eartag2.service.IDataService;
import com.huimv.eartag2.service.IDeviceService;
import com.huimv.eartag2.utils.DateUtil2;
import com.huimv.eartag2.utils.RegexUtil;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.util.CharsetUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@ChannelHandler.Sharable
@Component
@Slf4j
public class EartagServerHandler extends ChannelInboundHandlerAdapter {
    @Autowired
    private IDataService dataService;
    @Autowired
    private DateUtil2 dateUtil;
    @Autowired
    private RegexUtil regexUtil;
    @Autowired
    private IDeviceService deviceService;
    @Value("${data.input.flow}")
    private Integer dataInputFlow;
    private StringBuilder sb = null;
    private Integer num = 0;

    public void save(String text){
        if(this.sb == null){
            sb = new StringBuilder();
        }
        sb.append(text);
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        ByteBuf data = (ByteBuf) msg;
        ++num;
        String clientAskText = data.toString(CharsetUtil.UTF_8);
//        System.out.println(num+"次, 客户端消息clientAskText>>"+clientAskText);
//        System.out.println("客户端请求内容长度>>"+clientAskText.length());
        save(clientAskText);
//        System.out.println("sb.length>>"+sb.length());

    }

    //        clientAskText = clientAskText.replaceAll("\r","").replaceAll("\n","");
//        System.out.println("### 服务端接收数据 >>" + clientAskText);
//        //TEST-saveRawData()
////        deviceService.saveRawData(clientAskText);
//        //{}
//        int countPlus = regexUtil.countPlus(clientAskText);
//        if (countPlus < 4) {
//            System.out.println("当前数据为不完整数据，故丢弃.>>" + clientAskText);
//        } else {
//            //--处理客户端请求数据
//            //{拆分粘包数据}
//            JSONArray askJa = getPerData(clientAskText);
//            for (int a = 0; a < askJa.size(); a++) {
//                String askText = askJa.getString(a);
//                /////////////////////////////////////////////////////////////
//                //TEST-saveRawData()
////                deviceService.saveRawData(askText);
//                /////////////////////////////////////////////////////////////
//                if (dataInputFlow == 1) {
//                    //{处理请求内容}
//                    handleAskText(askText, ctx);
//                } else {
//                    //{处理请求内容2}
//                    handleAskText2(askText, ctx);
//                }
//            }
//        }

    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
//        ctx.writeAndFlush("111");
//        System.out.println("EchoServerHandle channelReadComplete");
//        ctx.close();

        if(sb.toString().indexOf("end") != -1){
            System.out.println("sb.toString()>>"+sb.toString());
            System.out.println("sb.length>>"+sb.length());
            System.out.println("输入完成.");
            sb.delete(0,sb.length());
            num = 0;
            System.out.println("清空sb实例. 长度>>"+sb.length());
        }

    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();

    }
}
