package com.huimv.eartag2.manage.listener;

import com.huimv.eartag2.common.mq.Const;
import com.huimv.eartag2.manage.service.IDeviceRegisterService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * 监听队列消息
 *
 * @author 静静
 * @since 2022-07-8
 */
@Component
@Slf4j
public class ManageListener {

    @Autowired
    private IDeviceRegisterService IDeviceRegisterService;

    @RabbitListener(queues = Const.QUEUE_SYNC_DEVICE_FANOUT)
    @RabbitHandler
    public void processSyncDeviceRegister(List<Map<String,String>> bizDeviceRegisters){
        System.out.println("---------------收到消息");
        IDeviceRegisterService.fanoutSyncDevice(bizDeviceRegisters);
    }

}
