package com.huimv.eartag2.manage.listener;

import com.alibaba.fastjson.JSONObject;
import com.huimv.eartag2.common.mq.Const;
import com.huimv.eartag2.manage.service.IDeviceService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
@Slf4j
public class ManageListener_cancel {
    @Autowired
    private IDeviceService deviceService;
    /**
     * @Method      : processSyncDeviceRegister
     * @Description : 监听处理同步设备注册信息队列
     * @Params      : [map]
     * @Return      : void
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/3/22
     * @Time        : 16:03
     */
//    @RabbitListener(queues = Const.QUEUE_SYNC_DEVICE_REGISTER)
//    @RabbitHandler
    public void processSyncDeviceRegister(Map map) throws ParseException {
        System.out.println("3.");
        JSONObject deviceRegisterJo = JSONObject.parseObject(map.get("deviceRegister").toString()) ;
//        System.out.println("同步设备注册信息>>"+deviceRegisterJo);
        //{计算有效设备总数并存储到缓存}
        deviceService.countEffectiveDeviceTotal(deviceRegisterJo);
        System.out.println("4.");

        //{计算设备和耳标总状态}
        deviceService.countFarmAllStatus(deviceRegisterJo);
        System.out.println("5.");
    }
}
