package com.huimv.eartag2.manage.service;

import com.huimv.eartag2.common.dao.entity.EartagDeviceRegisterEntity;
import com.huimv.eartag2.common.dao.entity.EartarFarmAllStatusEntity;

import java.util.List;
import java.util.Map;

public interface ICacheService {

    Map getFarmAllStatusByFarmId(String farmId);

    //读取设备在线数量
    int getDeviceOnlineTotal(String farmId, String todayDateText);

    //读取耳标在线数量
    int getEartagOnlineTotal(String farmId, String todayDateText);

    //
    void putFarmAllStatusCache(String farmId, EartarFarmAllStatusEntity newFarmAllStatusEntity);


    boolean isExistDeviceCode(String deviceCode);

    //
    int isExistAllDeviceSet();

    //
    void putAllDeviceSet(List list);

    //
    void putAllDeviceSet(String deviceCode);

    //将芯片ID加入到缓存中
    void putChipIdToCache(String chipId, String deviceCode);

    //将设备编码加入到设备注册当中
    void putDeviceRegister(String deviceCode, EartagDeviceRegisterEntity deviceRegisterEntity);

    //删除设备注册信息
    void deleteDeviceRegister(String deviceCode);

    //设置设备总数
    void putDeviceTotal_(Integer effectiveDeviceTotal, String farmId);

    //从集合set当中删除设备编号
    void deleteDeviceCodeSetCache(String deviceCode);

    //删除芯片ID缓存
    void deleteChipIdHashCache(String chipId);

    void getDeviceCodeSetCache();

    void deleteOnlineDeviceSet(String farmId, String deviceCode, String todayDateText);

    void putOnlineDeviceSet(String farmId, String deviceCode, String todayDateText);
}
