package com.huimv.eartag2.manage.utils;

import com.huimv.eartag2.common.utils.BizConst;
import com.huimv.eartag2.manage.service.ICacheService;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.test.context.TestPropertySource;

import java.util.Set;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@SpringBootTest
public class CacheTest {
    @Autowired
    private ICacheService cacheService;
    @Autowired
    private RedisTemplate redisTemplate;

    @Test
    public void testGetDeviceCodeSetCache(){
        cacheService.getDeviceCodeSetCache();
    }

    @Test
    public void testPutDeviceCodeSetCache(){
//        String chipId = "a848fad3fefb";
        String deviceCode = "202007239999873";
//        String deviceCode = "202007239999866";
        cacheService.putAllDeviceSet(deviceCode);
        cacheService.getDeviceCodeSetCache();
    }

    @Test
    public void testDelDeviceCode(){
        String setKey = BizConst.SET_ALL_DEVICE_PREFIX;
        String deviceCode = "202007239999866";
        redisTemplate.opsForSet().remove(setKey,deviceCode);
        cacheService.getDeviceCodeSetCache();
    }

    @Test
    public void testIsMember(){
//        String chipId = "a848fad3fefb";
        String deviceCode = "202007239999866";
//        cacheService.putAllDeviceSet(deviceCode);
//        cacheService.getDeviceCodeSetCache();
        cacheService.getDeviceCodeSetCache();
        String setKey = BizConst.SET_ALL_DEVICE_PREFIX;
        boolean isMember = redisTemplate.opsForSet().isMember(setKey,deviceCode);
        System.out.println("验证isMember="+isMember);
    }

    @Test
    public void testGetChipIdCache(){
        String key = BizConst.CHIP_DEVICE_PREFIX;
        String hashKey = "a848fad3fefb";
        //
        Object obj = redisTemplate.opsForHash().get(key,hashKey);
        if(obj == null){
            System.out.println("验证 obj="+obj);
        }else{
            System.out.println("验证 obj="+obj.toString());
        }
    }

    @Test
    public void testGetDeviceOnlineSum(){
        String farmId = "101";
        String todayDateText = "2022-04-01";
        String setKey = BizConst.SET_FARM_DEVICE_ONLINE_PREFIX + farmId+":"+todayDateText;
        Set<String> resultSet = redisTemplate.opsForSet().members(setKey);
        System.out.println("resultSet="+resultSet.toString());
        System.out.println("验证 resultSet.size="+resultSet.size());
    }

    @Test
    public void testGetDeviceTotal(){
        String farmId = "101";
        String valueKey = BizConst.FARM_DEVICE_TOTAL_PREFIX+farmId;
        Object obj = redisTemplate.opsForValue().get(valueKey);
        if(obj == null){
            System.out.println(""+obj);
        }else{
            System.out.println(Integer.parseInt(String.valueOf(obj)));
        }
    }
}
