package com.huimv.eartag2.manage.utils;

import java.io.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
public class Test006 {
    String file = "D:\\1\\16k_007.pcm";

    //
    public static void main(String[] args) throws FileNotFoundException {
        Test006 test = new Test006();

        //将16进制字符串转成二进制字节，再转成16进制字符串
//        test.testConvert();

        //执行写入流
        test.testWrite_1();
    }

    //将16进制字符转成字节，写入到文件中
    private void testWrite_1() throws FileNotFoundException {
        String hexStr = "B2FFE8FF0200FAFF";
//        String hexStr = "B2";
        System.out.println("写入内容="+hexStr);
        byte[] bytes = hexStrToBytes(hexStr);

        //test1
//        writeFile1(bytes);

        //test2
//        writeFile2(bytes);

        //test3
        writeFile3(bytes);

        readFile(file);

        System.out.println("写入完成.");
    }

    //读取文件
    private void readFile(String file) {
        System.out.println("开始读取内容");
        int data;
        int a = 0;
        try {
            DataInputStream isr = new DataInputStream(new FileInputStream(file));
            //逐行读
            while ((data = isr.read()) != -1) {
                System.out.printf("%02X", data & 0xFF);
                ++a;
            }
        } catch (Exception e) {
            System.out.println("Exception: " + e);
        }finally {
            System.out.println();
            System.out.println("a="+a);
        }
    }

    //
    private void writeFile3(byte[] bytes) throws FileNotFoundException {
//        String file = "D:\\1\\16k_006.pcm";
        DataOutputStream dos = null;
        FileOutputStream fos = null;
        try {
            //创建输出流（写入文件）
            fos = new FileOutputStream(file);
            dos = new DataOutputStream(fos);
            dos.write(bytes);
        } catch (Exception e) {
//            Log.error("write Exception:",e);
            e.printStackTrace();
        } finally {
            try {
                fos.close();
            } catch (IOException e) {
//                Log.error("fos.close() Exception:", e);
                System.out.println("" + e.getMessage());
            }
        }
    }

    //
    private void writeFile2(byte[] bytes) {
        String file = "D:\\1\\16k_005.bin";
        FileOutputStream fos = null;
        try {
            fos = new FileOutputStream(file);
            fos.write(bytes);
        } catch (Exception e) {
//            Log.error("write Exception:",e);
            e.printStackTrace();
        } finally {
            try {
                fos.close();
            } catch (IOException e) {
//                Log.error("fos.close() Exception:", e);
                System.out.println("" + e.getMessage());
            }
        }
    }

    //将二进制字节写入文件
    private void writeFile1(byte[] bytes) {
        //将字节数组写入data.bin文件
//        byte[] b = {1, 2};
        try {
//            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
            DataOutputStream os = new DataOutputStream(
                    new BufferedOutputStream(new FileOutputStream(
                            file)));
//            log.info(":{}",b);
//            os.write(b);
            os.write(bytes);
            os.flush();
            os.close();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            System.out.println("完成写入.");
        }
    }

    //转换
    private void testConvert() {
        String hexStr = "B2";
        byte[] bytes = hexStrToBytes(hexStr);
        String text = bytesToHexStr(bytes, true);
        System.out.println("text>>" + text);
    }

    /**
     * byte数组转成字符串
     *
     * @param bytes     数组
     * @param isCaptial 使用大写还是小写表示
     * @return 转换后的字符串
     */
    public String bytesToHexStr(byte[] bytes, boolean isCaptial) {
        if (null == bytes || bytes.length <= 0) {
            return null;
        }
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < bytes.length; i++) {
            if (isCaptial) {
                //02表示使用2位16进制字符表示当前的byte数据，X或者x表示16进制字符串
                s.append(String.format("%02X", bytes[i]));
            } else {
                s.append(String.format("%02x", bytes[i]));
            }
        }
        return s.toString();
    }

    /*
     * @Method      : hexStrToBytes
     * @Description : 将16进制字符串转成byte数组
     * @Params      : [hex]
     * @Return      : byte[]
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/3/30
     * @Time        : 9:10
     */
    public static byte[] hexStrToBytes(String hex) {
        if (null == hex || hex.equals("")) {
            return null;
        }
        int strLength = hex.length();//获取16进制字符串长度
        int length = strLength / 2; //获取字节长度
        char[] hexChars;//用来存放字符串转换成的字符数组
        if (length * 2 < strLength) { // strLength is odd, add '0'
            length += 1;
            hexChars = ("0" + hex).toCharArray();
        } else {
            hexChars = hex.toCharArray();
        }
        byte[] bytes = new byte[length];//用来存放最终组成的数组
        for (int i = 0; i < length; i++) {
            int pos = i * 2;
            //组成1字节的数据。因为是需要两个字符组成一个字节的数据，这就需要第一个字符向左移4位。
            bytes[i] = (byte) (charToByte(hexChars[pos]) << 4 | charToByte(hexChars[pos + 1]));
        }
        return bytes;
    }

    public static byte charToByte(char c) {
        byte result = (byte) "0123456789abcdef".indexOf(c);
        if (result == -1) {
            return (byte) "0123456789ABCDEF".indexOf(c);
        } else {
            return result;
        }
    }
}
