package com.huimv.eartag2.api;

import com.huimv.eartag2.api.netty.EartagServer;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.web.client.RestTemplate;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@SpringBootApplication
@EnableScheduling
@MapperScan("com.huimv.eartag2.api.mapper")
@EntityScan(value = "com.huimv.eartag2.common.dao.entity")
@EnableJpaRepositories(basePackages = "com.huimv.eartag2.common.dao.repo")
//@Import(InterceptorConfig.class)
public class HuimvManageApplication {
    public static void main(String[] args) throws InterruptedException {

        ApplicationContext applicationContext =   SpringApplication.run(HuimvManageApplication.class, args);
        applicationContext.getBean(EartagServer.class).run();
    }
    @Bean
    public static RestTemplate getRestTemplate(){
        return new RestTemplate();
    }
}
